#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class imath {
        
        public static ivec2 Dot(imat2 t0, ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec2 Dot(ref imat2 t0, ref ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(imat2 t0, imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(ref imat2 t0, ref imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(imat2 t0, imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(ref imat2 t0, ref imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(imat2 t0, imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(ref imat2 t0, ref imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec2 Dot(imat2x3 t0, ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec2 Dot(ref imat2x3 t0, ref ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(imat2x3 t0, imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(ref imat2x3 t0, ref imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(imat2x3 t0, imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(ref imat2x3 t0, ref imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(imat2x3 t0, imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(ref imat2x3 t0, ref imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec2 Dot(imat2x4 t0, ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec2 Dot(ref imat2x4 t0, ref ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(imat2x4 t0, imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2 Dot(ref imat2x4 t0, ref imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(imat2x4 t0, imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x3 Dot(ref imat2x4 t0, ref imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(imat2x4 t0, imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat2x4 Dot(ref imat2x4 t0, ref imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(imat3x2 t0, ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(ref imat3x2 t0, ref ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(imat3x2 t0, imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(ref imat3x2 t0, ref imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(imat3x2 t0, imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(ref imat3x2 t0, ref imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(imat3x2 t0, imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(ref imat3x2 t0, ref imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(imat3 t0, ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(ref imat3 t0, ref ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(imat3 t0, imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(ref imat3 t0, ref imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(imat3 t0, imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(ref imat3 t0, ref imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(imat3 t0, imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(ref imat3 t0, ref imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(imat3x4 t0, ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec3 Dot(ref imat3x4 t0, ref ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(imat3x4 t0, imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x2 Dot(ref imat3x4 t0, ref imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(imat3x4 t0, imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3 Dot(ref imat3x4 t0, ref imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(imat3x4 t0, imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat3x4 Dot(ref imat3x4 t0, ref imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(imat4x2 t0, ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(ref imat4x2 t0, ref ivec2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(imat4x2 t0, imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(ref imat4x2 t0, ref imat2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(imat4x2 t0, imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(ref imat4x2 t0, ref imat2x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(imat4x2 t0, imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(ref imat4x2 t0, ref imat2x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(imat4x3 t0, ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(ref imat4x3 t0, ref ivec3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(imat4x3 t0, imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(ref imat4x3 t0, ref imat3x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(imat4x3 t0, imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(ref imat4x3 t0, ref imat3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(imat4x3 t0, imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(ref imat4x3 t0, ref imat3x4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(imat4 t0, ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static ivec4 Dot(ref imat4 t0, ref ivec4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(imat4 t0, imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x2 Dot(ref imat4 t0, ref imat4x2 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(imat4 t0, imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4x3 Dot(ref imat4 t0, ref imat4x3 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(imat4 t0, imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
        
        public static imat4 Dot(ref imat4 t0, ref imat4 t1) {
            return imath.InnerProduct1(ref t0, ref t1);
        }
    }
}
