#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class umath {
        
        public static uint LengthSquared(uvec2 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static uint LengthSquared(ref uvec2 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static double Length(uvec2 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static double Length(ref uvec2 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static uint DistanceSquared(uvec2 v0, uvec2 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static uint DistanceSquared(ref uvec2 v0, ref uvec2 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static double Distance(uvec2 v0, uvec2 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static double Distance(ref uvec2 v0, ref uvec2 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static uint Dot(uvec2 t0, uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uint Dot(ref uvec2 t0, ref uvec2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(uvec2 t0, umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref uvec2 t0, ref umat2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(uvec2 t0, umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref uvec2 t0, ref umat2x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(uvec2 t0, umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref uvec2 t0, ref umat2x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uint LengthSquared(uvec3 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static uint LengthSquared(ref uvec3 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static double Length(uvec3 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static double Length(ref uvec3 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static uint DistanceSquared(uvec3 v0, uvec3 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static uint DistanceSquared(ref uvec3 v0, ref uvec3 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static double Distance(uvec3 v0, uvec3 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static double Distance(ref uvec3 v0, ref uvec3 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static uint Dot(uvec3 t0, uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uint Dot(ref uvec3 t0, ref uvec3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(uvec3 t0, umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref uvec3 t0, ref umat3x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(uvec3 t0, umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref uvec3 t0, ref umat3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(uvec3 t0, umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref uvec3 t0, ref umat3x4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uint LengthSquared(uvec4 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static uint LengthSquared(ref uvec4 v0) {
            return umath.MagnitudeSquared(ref v0);
        }
        
        public static double Length(uvec4 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static double Length(ref uvec4 v0) {
            return umath.Magnitude(ref v0);
        }
        
        public static uint DistanceSquared(uvec4 v0, uvec4 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static uint DistanceSquared(ref uvec4 v0, ref uvec4 v1) {
            return umath.MagnitudeSquared(v1 - v0);
        }
        
        public static double Distance(uvec4 v0, uvec4 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static double Distance(ref uvec4 v0, ref uvec4 v1) {
            return umath.Magnitude(v1 - v0);
        }
        
        public static uint Dot(uvec4 t0, uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uint Dot(ref uvec4 t0, ref uvec4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(uvec4 t0, umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec2 Dot(ref uvec4 t0, ref umat4x2 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(uvec4 t0, umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec3 Dot(ref uvec4 t0, ref umat4x3 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(uvec4 t0, umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
        
        public static uvec4 Dot(ref uvec4 t0, ref umat4 t1) {
            return umath.InnerProduct1(ref t0, ref t1);
        }
    }
}
