#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class dmath {
        
        public static double Determinant(dmat2 m0) {
            return (m0.m00 * m0.m11) + (-1 * m0.m01 * m0.m10);
        }
        
        public static double Determinant(ref dmat2 m0) {
            return (m0.m00 * m0.m11) + (-1 * m0.m01 * m0.m10);
        }
        
        public static dmat2 Cofactor(dmat2 m0) {
            return new dmat2((1D * dmath.Minor(ref m0, 0, 0)), (-1D * dmath.Minor(ref m0, 0, 1)), (-1D * dmath.Minor(ref m0, 1, 0)), (1D * dmath.Minor(ref m0, 1, 1)));
        }
        
        public static dmat2 Cofactor(ref dmat2 m0) {
            return new dmat2((1D * dmath.Minor(ref m0, 0, 0)), (-1D * dmath.Minor(ref m0, 0, 1)), (-1D * dmath.Minor(ref m0, 1, 0)), (1D * dmath.Minor(ref m0, 1, 1)));
        }
        
        public static dmat2 Inverse(dmat2 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
        
        public static dmat2 Inverse(ref dmat2 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
        
        public static double Determinant(dmat3 m0) {
            return (m0.m00 * m0.m11 * m0.m22) + (-1 * m0.m00 * m0.m12 * m0.m21) + (-1 * m0.m01 * m0.m10 * m0.m22) + (m0.m01 * m0.m12 * m0.m20) + (m0.m02 * m0.m10 * m0.m21) + (-1 * m0.m02 * m0.m11 * m0.m20);
        }
        
        public static double Determinant(ref dmat3 m0) {
            return (m0.m00 * m0.m11 * m0.m22) + (-1 * m0.m00 * m0.m12 * m0.m21) + (-1 * m0.m01 * m0.m10 * m0.m22) + (m0.m01 * m0.m12 * m0.m20) + (m0.m02 * m0.m10 * m0.m21) + (-1 * m0.m02 * m0.m11 * m0.m20);
        }
        
        public static dmat3 Cofactor(dmat3 m0) {
            return new dmat3((1D * dmath.Determinant(dmath.Minor(ref m0, 0, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 0, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 2))));
        }
        
        public static dmat3 Cofactor(ref dmat3 m0) {
            return new dmat3((1D * dmath.Determinant(dmath.Minor(ref m0, 0, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 0, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 2))));
        }
        
        public static dmat3 Inverse(dmat3 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
        
        public static dmat3 Inverse(ref dmat3 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
        
        public static double Determinant(dmat4 m0) {
            return (m0.m00 * m0.m11 * m0.m22 * m0.m33) + (-1 * m0.m00 * m0.m11 * m0.m23 * m0.m32) + (-1 * m0.m00 * m0.m12 * m0.m21 * m0.m33) + (m0.m00 * m0.m12 * m0.m23 * m0.m31) + (m0.m00 * m0.m13 * m0.m21 * m0.m32) + (-1 * m0.m00 * m0.m13 * m0.m22 * m0.m31) + (-1 * m0.m01 * m0.m10 * m0.m22 * m0.m33) + (m0.m01 * m0.m10 * m0.m23 * m0.m32) + (m0.m01 * m0.m12 * m0.m20 * m0.m33) + (-1 * m0.m01 * m0.m12 * m0.m23 * m0.m30) + (-1 * m0.m01 * m0.m13 * m0.m20 * m0.m32) + (m0.m01 * m0.m13 * m0.m22 * m0.m30) + (m0.m02 * m0.m10 * m0.m21 * m0.m33) + (-1 * m0.m02 * m0.m10 * m0.m23 * m0.m31) + (-1 * m0.m02 * m0.m11 * m0.m20 * m0.m33) + (m0.m02 * m0.m11 * m0.m23 * m0.m30) + (m0.m02 * m0.m13 * m0.m20 * m0.m31) + (-1 * m0.m02 * m0.m13 * m0.m21 * m0.m30) + (-1 * m0.m03 * m0.m10 * m0.m21 * m0.m32) + (m0.m03 * m0.m10 * m0.m22 * m0.m31) + (m0.m03 * m0.m11 * m0.m20 * m0.m32) + (-1 * m0.m03 * m0.m11 * m0.m22 * m0.m30) + (-1 * m0.m03 * m0.m12 * m0.m20 * m0.m31) + (m0.m03 * m0.m12 * m0.m21 * m0.m30);
        }
        
        public static double Determinant(ref dmat4 m0) {
            return (m0.m00 * m0.m11 * m0.m22 * m0.m33) + (-1 * m0.m00 * m0.m11 * m0.m23 * m0.m32) + (-1 * m0.m00 * m0.m12 * m0.m21 * m0.m33) + (m0.m00 * m0.m12 * m0.m23 * m0.m31) + (m0.m00 * m0.m13 * m0.m21 * m0.m32) + (-1 * m0.m00 * m0.m13 * m0.m22 * m0.m31) + (-1 * m0.m01 * m0.m10 * m0.m22 * m0.m33) + (m0.m01 * m0.m10 * m0.m23 * m0.m32) + (m0.m01 * m0.m12 * m0.m20 * m0.m33) + (-1 * m0.m01 * m0.m12 * m0.m23 * m0.m30) + (-1 * m0.m01 * m0.m13 * m0.m20 * m0.m32) + (m0.m01 * m0.m13 * m0.m22 * m0.m30) + (m0.m02 * m0.m10 * m0.m21 * m0.m33) + (-1 * m0.m02 * m0.m10 * m0.m23 * m0.m31) + (-1 * m0.m02 * m0.m11 * m0.m20 * m0.m33) + (m0.m02 * m0.m11 * m0.m23 * m0.m30) + (m0.m02 * m0.m13 * m0.m20 * m0.m31) + (-1 * m0.m02 * m0.m13 * m0.m21 * m0.m30) + (-1 * m0.m03 * m0.m10 * m0.m21 * m0.m32) + (m0.m03 * m0.m10 * m0.m22 * m0.m31) + (m0.m03 * m0.m11 * m0.m20 * m0.m32) + (-1 * m0.m03 * m0.m11 * m0.m22 * m0.m30) + (-1 * m0.m03 * m0.m12 * m0.m20 * m0.m31) + (m0.m03 * m0.m12 * m0.m21 * m0.m30);
        }
        
        public static dmat4 Cofactor(dmat4 m0) {
            return new dmat4((1D * dmath.Determinant(dmath.Minor(ref m0, 0, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 0, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 3))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 3))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 3))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 3, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 3, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 3, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 3, 3))));
        }
        
        public static dmat4 Cofactor(ref dmat4 m0) {
            return new dmat4((1D * dmath.Determinant(dmath.Minor(ref m0, 0, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 0, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 0, 3))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 1, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 1, 3))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 0))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 1))), (1D * dmath.Determinant(dmath.Minor(ref m0, 2, 2))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 2, 3))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 3, 0))), (1D * dmath.Determinant(dmath.Minor(ref m0, 3, 1))), (-1D * dmath.Determinant(dmath.Minor(ref m0, 3, 2))), (1D * dmath.Determinant(dmath.Minor(ref m0, 3, 3))));
        }
        
        public static dmat4 Inverse(dmat4 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
        
        public static dmat4 Inverse(ref dmat4 m0) {
            return ((1D / dmath.Determinant(ref m0)) 
                        * dmath.Transpose(dmath.Cofactor(ref m0)));
        }
    }
}
