#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static float Determinant(mat2 m0) {
            return (m0.m00 * m0.m11) + (-1 * m0.m01 * m0.m10);
        }
        
        public static float Determinant(ref mat2 m0) {
            return (m0.m00 * m0.m11) + (-1 * m0.m01 * m0.m10);
        }
        
        public static mat2 Cofactor(mat2 m0) {
            return new mat2((1F * math.Minor(ref m0, 0, 0)), (-1F * math.Minor(ref m0, 0, 1)), (-1F * math.Minor(ref m0, 1, 0)), (1F * math.Minor(ref m0, 1, 1)));
        }
        
        public static mat2 Cofactor(ref mat2 m0) {
            return new mat2((1F * math.Minor(ref m0, 0, 0)), (-1F * math.Minor(ref m0, 0, 1)), (-1F * math.Minor(ref m0, 1, 0)), (1F * math.Minor(ref m0, 1, 1)));
        }
        
        public static mat2 Inverse(mat2 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
        
        public static mat2 Inverse(ref mat2 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
        
        public static float Determinant(mat3 m0) {
            return (m0.m00 * m0.m11 * m0.m22) + (-1 * m0.m00 * m0.m12 * m0.m21) + (-1 * m0.m01 * m0.m10 * m0.m22) + (m0.m01 * m0.m12 * m0.m20) + (m0.m02 * m0.m10 * m0.m21) + (-1 * m0.m02 * m0.m11 * m0.m20);
        }
        
        public static float Determinant(ref mat3 m0) {
            return (m0.m00 * m0.m11 * m0.m22) + (-1 * m0.m00 * m0.m12 * m0.m21) + (-1 * m0.m01 * m0.m10 * m0.m22) + (m0.m01 * m0.m12 * m0.m20) + (m0.m02 * m0.m10 * m0.m21) + (-1 * m0.m02 * m0.m11 * m0.m20);
        }
        
        public static mat3 Cofactor(mat3 m0) {
            return new mat3((1F * math.Determinant(math.Minor(ref m0, 0, 0))), (-1F * math.Determinant(math.Minor(ref m0, 0, 1))), (1F * math.Determinant(math.Minor(ref m0, 0, 2))), (-1F * math.Determinant(math.Minor(ref m0, 1, 0))), (1F * math.Determinant(math.Minor(ref m0, 1, 1))), (-1F * math.Determinant(math.Minor(ref m0, 1, 2))), (1F * math.Determinant(math.Minor(ref m0, 2, 0))), (-1F * math.Determinant(math.Minor(ref m0, 2, 1))), (1F * math.Determinant(math.Minor(ref m0, 2, 2))));
        }
        
        public static mat3 Cofactor(ref mat3 m0) {
            return new mat3((1F * math.Determinant(math.Minor(ref m0, 0, 0))), (-1F * math.Determinant(math.Minor(ref m0, 0, 1))), (1F * math.Determinant(math.Minor(ref m0, 0, 2))), (-1F * math.Determinant(math.Minor(ref m0, 1, 0))), (1F * math.Determinant(math.Minor(ref m0, 1, 1))), (-1F * math.Determinant(math.Minor(ref m0, 1, 2))), (1F * math.Determinant(math.Minor(ref m0, 2, 0))), (-1F * math.Determinant(math.Minor(ref m0, 2, 1))), (1F * math.Determinant(math.Minor(ref m0, 2, 2))));
        }
        
        public static mat3 Inverse(mat3 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
        
        public static mat3 Inverse(ref mat3 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
        
        public static float Determinant(mat4 m0) {
            return (m0.m00 * m0.m11 * m0.m22 * m0.m33) + (-1 * m0.m00 * m0.m11 * m0.m23 * m0.m32) + (-1 * m0.m00 * m0.m12 * m0.m21 * m0.m33) + (m0.m00 * m0.m12 * m0.m23 * m0.m31) + (m0.m00 * m0.m13 * m0.m21 * m0.m32) + (-1 * m0.m00 * m0.m13 * m0.m22 * m0.m31) + (-1 * m0.m01 * m0.m10 * m0.m22 * m0.m33) + (m0.m01 * m0.m10 * m0.m23 * m0.m32) + (m0.m01 * m0.m12 * m0.m20 * m0.m33) + (-1 * m0.m01 * m0.m12 * m0.m23 * m0.m30) + (-1 * m0.m01 * m0.m13 * m0.m20 * m0.m32) + (m0.m01 * m0.m13 * m0.m22 * m0.m30) + (m0.m02 * m0.m10 * m0.m21 * m0.m33) + (-1 * m0.m02 * m0.m10 * m0.m23 * m0.m31) + (-1 * m0.m02 * m0.m11 * m0.m20 * m0.m33) + (m0.m02 * m0.m11 * m0.m23 * m0.m30) + (m0.m02 * m0.m13 * m0.m20 * m0.m31) + (-1 * m0.m02 * m0.m13 * m0.m21 * m0.m30) + (-1 * m0.m03 * m0.m10 * m0.m21 * m0.m32) + (m0.m03 * m0.m10 * m0.m22 * m0.m31) + (m0.m03 * m0.m11 * m0.m20 * m0.m32) + (-1 * m0.m03 * m0.m11 * m0.m22 * m0.m30) + (-1 * m0.m03 * m0.m12 * m0.m20 * m0.m31) + (m0.m03 * m0.m12 * m0.m21 * m0.m30);
        }
        
        public static float Determinant(ref mat4 m0) {
            return (m0.m00 * m0.m11 * m0.m22 * m0.m33) + (-1 * m0.m00 * m0.m11 * m0.m23 * m0.m32) + (-1 * m0.m00 * m0.m12 * m0.m21 * m0.m33) + (m0.m00 * m0.m12 * m0.m23 * m0.m31) + (m0.m00 * m0.m13 * m0.m21 * m0.m32) + (-1 * m0.m00 * m0.m13 * m0.m22 * m0.m31) + (-1 * m0.m01 * m0.m10 * m0.m22 * m0.m33) + (m0.m01 * m0.m10 * m0.m23 * m0.m32) + (m0.m01 * m0.m12 * m0.m20 * m0.m33) + (-1 * m0.m01 * m0.m12 * m0.m23 * m0.m30) + (-1 * m0.m01 * m0.m13 * m0.m20 * m0.m32) + (m0.m01 * m0.m13 * m0.m22 * m0.m30) + (m0.m02 * m0.m10 * m0.m21 * m0.m33) + (-1 * m0.m02 * m0.m10 * m0.m23 * m0.m31) + (-1 * m0.m02 * m0.m11 * m0.m20 * m0.m33) + (m0.m02 * m0.m11 * m0.m23 * m0.m30) + (m0.m02 * m0.m13 * m0.m20 * m0.m31) + (-1 * m0.m02 * m0.m13 * m0.m21 * m0.m30) + (-1 * m0.m03 * m0.m10 * m0.m21 * m0.m32) + (m0.m03 * m0.m10 * m0.m22 * m0.m31) + (m0.m03 * m0.m11 * m0.m20 * m0.m32) + (-1 * m0.m03 * m0.m11 * m0.m22 * m0.m30) + (-1 * m0.m03 * m0.m12 * m0.m20 * m0.m31) + (m0.m03 * m0.m12 * m0.m21 * m0.m30);
        }
        
        public static mat4 Cofactor(mat4 m0) {
            return new mat4((1F * math.Determinant(math.Minor(ref m0, 0, 0))), (-1F * math.Determinant(math.Minor(ref m0, 0, 1))), (1F * math.Determinant(math.Minor(ref m0, 0, 2))), (-1F * math.Determinant(math.Minor(ref m0, 0, 3))), (-1F * math.Determinant(math.Minor(ref m0, 1, 0))), (1F * math.Determinant(math.Minor(ref m0, 1, 1))), (-1F * math.Determinant(math.Minor(ref m0, 1, 2))), (1F * math.Determinant(math.Minor(ref m0, 1, 3))), (1F * math.Determinant(math.Minor(ref m0, 2, 0))), (-1F * math.Determinant(math.Minor(ref m0, 2, 1))), (1F * math.Determinant(math.Minor(ref m0, 2, 2))), (-1F * math.Determinant(math.Minor(ref m0, 2, 3))), (-1F * math.Determinant(math.Minor(ref m0, 3, 0))), (1F * math.Determinant(math.Minor(ref m0, 3, 1))), (-1F * math.Determinant(math.Minor(ref m0, 3, 2))), (1F * math.Determinant(math.Minor(ref m0, 3, 3))));
        }
        
        public static mat4 Cofactor(ref mat4 m0) {
            return new mat4((1F * math.Determinant(math.Minor(ref m0, 0, 0))), (-1F * math.Determinant(math.Minor(ref m0, 0, 1))), (1F * math.Determinant(math.Minor(ref m0, 0, 2))), (-1F * math.Determinant(math.Minor(ref m0, 0, 3))), (-1F * math.Determinant(math.Minor(ref m0, 1, 0))), (1F * math.Determinant(math.Minor(ref m0, 1, 1))), (-1F * math.Determinant(math.Minor(ref m0, 1, 2))), (1F * math.Determinant(math.Minor(ref m0, 1, 3))), (1F * math.Determinant(math.Minor(ref m0, 2, 0))), (-1F * math.Determinant(math.Minor(ref m0, 2, 1))), (1F * math.Determinant(math.Minor(ref m0, 2, 2))), (-1F * math.Determinant(math.Minor(ref m0, 2, 3))), (-1F * math.Determinant(math.Minor(ref m0, 3, 0))), (1F * math.Determinant(math.Minor(ref m0, 3, 1))), (-1F * math.Determinant(math.Minor(ref m0, 3, 2))), (1F * math.Determinant(math.Minor(ref m0, 3, 3))));
        }
        
        public static mat4 Inverse(mat4 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
        
        public static mat4 Inverse(ref mat4 m0) {
            return ((1F / math.Determinant(ref m0)) 
                        * math.Transpose(math.Cofactor(ref m0)));
        }
    }
}
