#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class dmath {
        
        public static void UnaryPlus(ref dvec2 t, out dvec2 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
        }
        
        public static void Negate(ref dvec2 t, out dvec2 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
        }
        
        public static void Increment(ref dvec2 t, out dvec2 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
        }
        
        public static void Decrement(ref dvec2 t, out dvec2 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
        }
        
        public static void Add(double s1, ref dvec2 t2, out dvec2 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
        }
        
        public static void Subtract(double s1, ref dvec2 t2, out dvec2 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
        }
        
        public static void Multiply(double s1, ref dvec2 t2, out dvec2 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
        }
        
        public static void Divide(double s1, ref dvec2 t2, out dvec2 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
        }
        
        public static void Modulo(double s1, ref dvec2 t2, out dvec2 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
        }
        
        public static void Add(ref dvec2 t1, double s2, out dvec2 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
        }
        
        public static void Subtract(ref dvec2 t1, double s2, out dvec2 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
        }
        
        public static void Multiply(ref dvec2 t1, double s2, out dvec2 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
        }
        
        public static void Divide(ref dvec2 t1, double s2, out dvec2 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
        }
        
        public static void Modulo(ref dvec2 t1, double s2, out dvec2 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
        }
        
        public static void Add(ref dvec2 t1, ref dvec2 t2, out dvec2 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
        }
        
        public static void Subtract(ref dvec2 t1, ref dvec2 t2, out dvec2 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
        }
        
        public static void Multiply(ref dvec2 t1, ref dvec2 t2, out dvec2 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
        }
        
        public static void Divide(ref dvec2 t1, ref dvec2 t2, out dvec2 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
        }
        
        public static void Modulo(ref dvec2 t1, ref dvec2 t2, out dvec2 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
        }
        
        public static void Equal(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
        }
        
        public static void GreaterThan(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
        }
        
        public static void GreaterThanEqual(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
        }
        
        public static void LessThan(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
        }
        
        public static void LessThanEqual(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
        }
        
        public static void NotEqual(ref dvec2 t1, ref dvec2 t2, out bvec2 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
        }
        
        public static void UnaryPlus(ref dvec3 t, out dvec3 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
            r.v2 = +t.v2;
        }
        
        public static void Negate(ref dvec3 t, out dvec3 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
            r.v2 = -t.v2;
        }
        
        public static void Increment(ref dvec3 t, out dvec3 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
            r.v2 = ++t.v2;
        }
        
        public static void Decrement(ref dvec3 t, out dvec3 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
            r.v2 = --t.v2;
        }
        
        public static void Add(double s1, ref dvec3 t2, out dvec3 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
            r.v2 = s1 + t2.v2;
        }
        
        public static void Subtract(double s1, ref dvec3 t2, out dvec3 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
            r.v2 = s1 - t2.v2;
        }
        
        public static void Multiply(double s1, ref dvec3 t2, out dvec3 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
            r.v2 = s1 * t2.v2;
        }
        
        public static void Divide(double s1, ref dvec3 t2, out dvec3 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
            r.v2 = s1 / t2.v2;
        }
        
        public static void Modulo(double s1, ref dvec3 t2, out dvec3 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
            r.v2 = s1 % t2.v2;
        }
        
        public static void Add(ref dvec3 t1, double s2, out dvec3 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
            r.v2 = t1.v2 + s2;
        }
        
        public static void Subtract(ref dvec3 t1, double s2, out dvec3 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
            r.v2 = t1.v2 - s2;
        }
        
        public static void Multiply(ref dvec3 t1, double s2, out dvec3 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
            r.v2 = t1.v2 * s2;
        }
        
        public static void Divide(ref dvec3 t1, double s2, out dvec3 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
            r.v2 = t1.v2 / s2;
        }
        
        public static void Modulo(ref dvec3 t1, double s2, out dvec3 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
            r.v2 = t1.v2 % s2;
        }
        
        public static void Add(ref dvec3 t1, ref dvec3 t2, out dvec3 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
            r.v2 = t1.v2 + t2.v2;
        }
        
        public static void Subtract(ref dvec3 t1, ref dvec3 t2, out dvec3 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
            r.v2 = t1.v2 - t2.v2;
        }
        
        public static void Multiply(ref dvec3 t1, ref dvec3 t2, out dvec3 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
            r.v2 = t1.v2 * t2.v2;
        }
        
        public static void Divide(ref dvec3 t1, ref dvec3 t2, out dvec3 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
            r.v2 = t1.v2 / t2.v2;
        }
        
        public static void Modulo(ref dvec3 t1, ref dvec3 t2, out dvec3 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
            r.v2 = t1.v2 % t2.v2;
        }
        
        public static void Equal(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
            r.v2 = t1.v2 == t2.v2;
        }
        
        public static void GreaterThan(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
            r.v2 = t1.v2 > t2.v2;
        }
        
        public static void GreaterThanEqual(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
            r.v2 = t1.v2 >= t2.v2;
        }
        
        public static void LessThan(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
            r.v2 = t1.v2 < t2.v2;
        }
        
        public static void LessThanEqual(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
            r.v2 = t1.v2 <= t2.v2;
        }
        
        public static void NotEqual(ref dvec3 t1, ref dvec3 t2, out bvec3 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
            r.v2 = t1.v2 != t2.v2;
        }
        
        public static void UnaryPlus(ref dvec4 t, out dvec4 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
            r.v2 = +t.v2;
            r.v3 = +t.v3;
        }
        
        public static void Negate(ref dvec4 t, out dvec4 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
            r.v2 = -t.v2;
            r.v3 = -t.v3;
        }
        
        public static void Increment(ref dvec4 t, out dvec4 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
            r.v2 = ++t.v2;
            r.v3 = ++t.v3;
        }
        
        public static void Decrement(ref dvec4 t, out dvec4 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
            r.v2 = --t.v2;
            r.v3 = --t.v3;
        }
        
        public static void Add(double s1, ref dvec4 t2, out dvec4 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
            r.v2 = s1 + t2.v2;
            r.v3 = s1 + t2.v3;
        }
        
        public static void Subtract(double s1, ref dvec4 t2, out dvec4 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
            r.v2 = s1 - t2.v2;
            r.v3 = s1 - t2.v3;
        }
        
        public static void Multiply(double s1, ref dvec4 t2, out dvec4 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
            r.v2 = s1 * t2.v2;
            r.v3 = s1 * t2.v3;
        }
        
        public static void Divide(double s1, ref dvec4 t2, out dvec4 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
            r.v2 = s1 / t2.v2;
            r.v3 = s1 / t2.v3;
        }
        
        public static void Modulo(double s1, ref dvec4 t2, out dvec4 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
            r.v2 = s1 % t2.v2;
            r.v3 = s1 % t2.v3;
        }
        
        public static void Add(ref dvec4 t1, double s2, out dvec4 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
            r.v2 = t1.v2 + s2;
            r.v3 = t1.v3 + s2;
        }
        
        public static void Subtract(ref dvec4 t1, double s2, out dvec4 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
            r.v2 = t1.v2 - s2;
            r.v3 = t1.v3 - s2;
        }
        
        public static void Multiply(ref dvec4 t1, double s2, out dvec4 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
            r.v2 = t1.v2 * s2;
            r.v3 = t1.v3 * s2;
        }
        
        public static void Divide(ref dvec4 t1, double s2, out dvec4 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
            r.v2 = t1.v2 / s2;
            r.v3 = t1.v3 / s2;
        }
        
        public static void Modulo(ref dvec4 t1, double s2, out dvec4 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
            r.v2 = t1.v2 % s2;
            r.v3 = t1.v3 % s2;
        }
        
        public static void Add(ref dvec4 t1, ref dvec4 t2, out dvec4 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
            r.v2 = t1.v2 + t2.v2;
            r.v3 = t1.v3 + t2.v3;
        }
        
        public static void Subtract(ref dvec4 t1, ref dvec4 t2, out dvec4 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
            r.v2 = t1.v2 - t2.v2;
            r.v3 = t1.v3 - t2.v3;
        }
        
        public static void Multiply(ref dvec4 t1, ref dvec4 t2, out dvec4 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
            r.v2 = t1.v2 * t2.v2;
            r.v3 = t1.v3 * t2.v3;
        }
        
        public static void Divide(ref dvec4 t1, ref dvec4 t2, out dvec4 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
            r.v2 = t1.v2 / t2.v2;
            r.v3 = t1.v3 / t2.v3;
        }
        
        public static void Modulo(ref dvec4 t1, ref dvec4 t2, out dvec4 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
            r.v2 = t1.v2 % t2.v2;
            r.v3 = t1.v3 % t2.v3;
        }
        
        public static void Equal(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
            r.v2 = t1.v2 == t2.v2;
            r.v3 = t1.v3 == t2.v3;
        }
        
        public static void GreaterThan(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
            r.v2 = t1.v2 > t2.v2;
            r.v3 = t1.v3 > t2.v3;
        }
        
        public static void GreaterThanEqual(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
            r.v2 = t1.v2 >= t2.v2;
            r.v3 = t1.v3 >= t2.v3;
        }
        
        public static void LessThan(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
            r.v2 = t1.v2 < t2.v2;
            r.v3 = t1.v3 < t2.v3;
        }
        
        public static void LessThanEqual(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
            r.v2 = t1.v2 <= t2.v2;
            r.v3 = t1.v3 <= t2.v3;
        }
        
        public static void NotEqual(ref dvec4 t1, ref dvec4 t2, out bvec4 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
            r.v2 = t1.v2 != t2.v2;
            r.v3 = t1.v3 != t2.v3;
        }
    }
}
