#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static void UnaryPlus(ref mat2 t, out mat2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
        }
        
        public static void Negate(ref mat2 t, out mat2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
        }
        
        public static void Increment(ref mat2 t, out mat2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
        }
        
        public static void Decrement(ref mat2 t, out mat2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
        }
        
        public static void Add(float s1, ref mat2 t2, out mat2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
        }
        
        public static void Subtract(float s1, ref mat2 t2, out mat2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
        }
        
        public static void Multiply(float s1, ref mat2 t2, out mat2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
        }
        
        public static void Divide(float s1, ref mat2 t2, out mat2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
        }
        
        public static void Modulo(float s1, ref mat2 t2, out mat2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
        }
        
        public static void Add(ref mat2 t1, float s2, out mat2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
        }
        
        public static void Subtract(ref mat2 t1, float s2, out mat2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
        }
        
        public static void Multiply(ref mat2 t1, float s2, out mat2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
        }
        
        public static void Divide(ref mat2 t1, float s2, out mat2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
        }
        
        public static void Modulo(ref mat2 t1, float s2, out mat2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
        }
        
        public static void Add(ref mat2 t1, ref mat2 t2, out mat2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
        }
        
        public static void Subtract(ref mat2 t1, ref mat2 t2, out mat2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
        }
        
        public static void Multiply(ref mat2 t1, ref mat2 t2, out mat2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
        }
        
        public static void Divide(ref mat2 t1, ref mat2 t2, out mat2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
        }
        
        public static void Modulo(ref mat2 t1, ref mat2 t2, out mat2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
        }
        
        public static void Equal(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
        }
        
        public static void GreaterThan(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
        }
        
        public static void GreaterThanEqual(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
        }
        
        public static void LessThan(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
        }
        
        public static void LessThanEqual(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
        }
        
        public static void NotEqual(ref mat2 t1, ref mat2 t2, out bmat2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
        }
        
        public static void UnaryPlus(ref mat2x3 t, out mat2x3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
        }
        
        public static void Negate(ref mat2x3 t, out mat2x3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
        }
        
        public static void Increment(ref mat2x3 t, out mat2x3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
        }
        
        public static void Decrement(ref mat2x3 t, out mat2x3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
        }
        
        public static void Add(float s1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
        }
        
        public static void Subtract(float s1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
        }
        
        public static void Multiply(float s1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
        }
        
        public static void Divide(float s1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
        }
        
        public static void Modulo(float s1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
        }
        
        public static void Add(ref mat2x3 t1, float s2, out mat2x3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
        }
        
        public static void Subtract(ref mat2x3 t1, float s2, out mat2x3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
        }
        
        public static void Multiply(ref mat2x3 t1, float s2, out mat2x3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
        }
        
        public static void Divide(ref mat2x3 t1, float s2, out mat2x3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
        }
        
        public static void Modulo(ref mat2x3 t1, float s2, out mat2x3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
        }
        
        public static void Add(ref mat2x3 t1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
        }
        
        public static void Subtract(ref mat2x3 t1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
        }
        
        public static void Multiply(ref mat2x3 t1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
        }
        
        public static void Divide(ref mat2x3 t1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
        }
        
        public static void Modulo(ref mat2x3 t1, ref mat2x3 t2, out mat2x3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
        }
        
        public static void Equal(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
        }
        
        public static void GreaterThan(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
        }
        
        public static void GreaterThanEqual(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
        }
        
        public static void LessThan(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
        }
        
        public static void LessThanEqual(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
        }
        
        public static void NotEqual(ref mat2x3 t1, ref mat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
        }
        
        public static void UnaryPlus(ref mat2x4 t, out mat2x4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
        }
        
        public static void Negate(ref mat2x4 t, out mat2x4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
        }
        
        public static void Increment(ref mat2x4 t, out mat2x4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
        }
        
        public static void Decrement(ref mat2x4 t, out mat2x4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
        }
        
        public static void Add(float s1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
        }
        
        public static void Subtract(float s1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
        }
        
        public static void Multiply(float s1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
        }
        
        public static void Divide(float s1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
        }
        
        public static void Modulo(float s1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
        }
        
        public static void Add(ref mat2x4 t1, float s2, out mat2x4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
        }
        
        public static void Subtract(ref mat2x4 t1, float s2, out mat2x4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
        }
        
        public static void Multiply(ref mat2x4 t1, float s2, out mat2x4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
        }
        
        public static void Divide(ref mat2x4 t1, float s2, out mat2x4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
        }
        
        public static void Modulo(ref mat2x4 t1, float s2, out mat2x4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
        }
        
        public static void Add(ref mat2x4 t1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
        }
        
        public static void Subtract(ref mat2x4 t1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
        }
        
        public static void Multiply(ref mat2x4 t1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
        }
        
        public static void Divide(ref mat2x4 t1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
        }
        
        public static void Modulo(ref mat2x4 t1, ref mat2x4 t2, out mat2x4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
        }
        
        public static void Equal(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
        }
        
        public static void GreaterThan(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
        }
        
        public static void GreaterThanEqual(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
        }
        
        public static void LessThan(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
        }
        
        public static void LessThanEqual(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
        }
        
        public static void NotEqual(ref mat2x4 t1, ref mat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
        }
        
        public static void UnaryPlus(ref mat3x2 t, out mat3x2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
        }
        
        public static void Negate(ref mat3x2 t, out mat3x2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
        }
        
        public static void Increment(ref mat3x2 t, out mat3x2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
        }
        
        public static void Decrement(ref mat3x2 t, out mat3x2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
        }
        
        public static void Add(float s1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
        }
        
        public static void Subtract(float s1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
        }
        
        public static void Multiply(float s1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
        }
        
        public static void Divide(float s1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
        }
        
        public static void Modulo(float s1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
        }
        
        public static void Add(ref mat3x2 t1, float s2, out mat3x2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
        }
        
        public static void Subtract(ref mat3x2 t1, float s2, out mat3x2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
        }
        
        public static void Multiply(ref mat3x2 t1, float s2, out mat3x2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
        }
        
        public static void Divide(ref mat3x2 t1, float s2, out mat3x2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
        }
        
        public static void Modulo(ref mat3x2 t1, float s2, out mat3x2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
        }
        
        public static void Add(ref mat3x2 t1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
        }
        
        public static void Subtract(ref mat3x2 t1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
        }
        
        public static void Multiply(ref mat3x2 t1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
        }
        
        public static void Divide(ref mat3x2 t1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
        }
        
        public static void Modulo(ref mat3x2 t1, ref mat3x2 t2, out mat3x2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
        }
        
        public static void Equal(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
        }
        
        public static void GreaterThan(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
        }
        
        public static void GreaterThanEqual(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
        }
        
        public static void LessThan(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
        }
        
        public static void LessThanEqual(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
        }
        
        public static void NotEqual(ref mat3x2 t1, ref mat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
        }
        
        public static void UnaryPlus(ref mat3 t, out mat3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
        }
        
        public static void Negate(ref mat3 t, out mat3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
        }
        
        public static void Increment(ref mat3 t, out mat3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
        }
        
        public static void Decrement(ref mat3 t, out mat3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
        }
        
        public static void Add(float s1, ref mat3 t2, out mat3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
        }
        
        public static void Subtract(float s1, ref mat3 t2, out mat3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
        }
        
        public static void Multiply(float s1, ref mat3 t2, out mat3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
        }
        
        public static void Divide(float s1, ref mat3 t2, out mat3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
        }
        
        public static void Modulo(float s1, ref mat3 t2, out mat3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
        }
        
        public static void Add(ref mat3 t1, float s2, out mat3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
        }
        
        public static void Subtract(ref mat3 t1, float s2, out mat3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
        }
        
        public static void Multiply(ref mat3 t1, float s2, out mat3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
        }
        
        public static void Divide(ref mat3 t1, float s2, out mat3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
        }
        
        public static void Modulo(ref mat3 t1, float s2, out mat3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
        }
        
        public static void Add(ref mat3 t1, ref mat3 t2, out mat3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
        }
        
        public static void Subtract(ref mat3 t1, ref mat3 t2, out mat3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
        }
        
        public static void Multiply(ref mat3 t1, ref mat3 t2, out mat3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
        }
        
        public static void Divide(ref mat3 t1, ref mat3 t2, out mat3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
        }
        
        public static void Modulo(ref mat3 t1, ref mat3 t2, out mat3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
        }
        
        public static void Equal(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
        }
        
        public static void GreaterThan(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
        }
        
        public static void GreaterThanEqual(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
        }
        
        public static void LessThan(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
        }
        
        public static void LessThanEqual(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
        }
        
        public static void NotEqual(ref mat3 t1, ref mat3 t2, out bmat3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
        }
        
        public static void UnaryPlus(ref mat3x4 t, out mat3x4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m23 = +t.m23;
        }
        
        public static void Negate(ref mat3x4 t, out mat3x4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m23 = -t.m23;
        }
        
        public static void Increment(ref mat3x4 t, out mat3x4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m23 = ++t.m23;
        }
        
        public static void Decrement(ref mat3x4 t, out mat3x4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m23 = --t.m23;
        }
        
        public static void Add(float s1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m23 = s1 + t2.m23;
        }
        
        public static void Subtract(float s1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m23 = s1 - t2.m23;
        }
        
        public static void Multiply(float s1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m23 = s1 * t2.m23;
        }
        
        public static void Divide(float s1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m23 = s1 / t2.m23;
        }
        
        public static void Modulo(float s1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m23 = s1 % t2.m23;
        }
        
        public static void Add(ref mat3x4 t1, float s2, out mat3x4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m23 = t1.m23 + s2;
        }
        
        public static void Subtract(ref mat3x4 t1, float s2, out mat3x4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m23 = t1.m23 - s2;
        }
        
        public static void Multiply(ref mat3x4 t1, float s2, out mat3x4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m23 = t1.m23 * s2;
        }
        
        public static void Divide(ref mat3x4 t1, float s2, out mat3x4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m23 = t1.m23 / s2;
        }
        
        public static void Modulo(ref mat3x4 t1, float s2, out mat3x4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m23 = t1.m23 % s2;
        }
        
        public static void Add(ref mat3x4 t1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m23 = t1.m23 + t2.m23;
        }
        
        public static void Subtract(ref mat3x4 t1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m23 = t1.m23 - t2.m23;
        }
        
        public static void Multiply(ref mat3x4 t1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m23 = t1.m23 * t2.m23;
        }
        
        public static void Divide(ref mat3x4 t1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m23 = t1.m23 / t2.m23;
        }
        
        public static void Modulo(ref mat3x4 t1, ref mat3x4 t2, out mat3x4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m23 = t1.m23 % t2.m23;
        }
        
        public static void Equal(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m23 = t1.m23 == t2.m23;
        }
        
        public static void GreaterThan(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m23 = t1.m23 > t2.m23;
        }
        
        public static void GreaterThanEqual(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m23 = t1.m23 >= t2.m23;
        }
        
        public static void LessThan(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m23 = t1.m23 < t2.m23;
        }
        
        public static void LessThanEqual(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m23 = t1.m23 <= t2.m23;
        }
        
        public static void NotEqual(ref mat3x4 t1, ref mat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m23 = t1.m23 != t2.m23;
        }
        
        public static void UnaryPlus(ref mat4x2 t, out mat4x2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
        }
        
        public static void Negate(ref mat4x2 t, out mat4x2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
        }
        
        public static void Increment(ref mat4x2 t, out mat4x2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
        }
        
        public static void Decrement(ref mat4x2 t, out mat4x2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
        }
        
        public static void Add(float s1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
        }
        
        public static void Subtract(float s1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
        }
        
        public static void Multiply(float s1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
        }
        
        public static void Divide(float s1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
        }
        
        public static void Modulo(float s1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
        }
        
        public static void Add(ref mat4x2 t1, float s2, out mat4x2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
        }
        
        public static void Subtract(ref mat4x2 t1, float s2, out mat4x2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
        }
        
        public static void Multiply(ref mat4x2 t1, float s2, out mat4x2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
        }
        
        public static void Divide(ref mat4x2 t1, float s2, out mat4x2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
        }
        
        public static void Modulo(ref mat4x2 t1, float s2, out mat4x2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
        }
        
        public static void Add(ref mat4x2 t1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
        }
        
        public static void Subtract(ref mat4x2 t1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
        }
        
        public static void Multiply(ref mat4x2 t1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
        }
        
        public static void Divide(ref mat4x2 t1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
        }
        
        public static void Modulo(ref mat4x2 t1, ref mat4x2 t2, out mat4x2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
        }
        
        public static void Equal(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
        }
        
        public static void GreaterThan(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
        }
        
        public static void GreaterThanEqual(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
        }
        
        public static void LessThan(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
        }
        
        public static void LessThanEqual(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
        }
        
        public static void NotEqual(ref mat4x2 t1, ref mat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
        }
        
        public static void UnaryPlus(ref mat4x3 t, out mat4x3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
            r.m32 = +t.m32;
        }
        
        public static void Negate(ref mat4x3 t, out mat4x3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
            r.m32 = -t.m32;
        }
        
        public static void Increment(ref mat4x3 t, out mat4x3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
            r.m32 = ++t.m32;
        }
        
        public static void Decrement(ref mat4x3 t, out mat4x3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
            r.m32 = --t.m32;
        }
        
        public static void Add(float s1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
            r.m32 = s1 + t2.m32;
        }
        
        public static void Subtract(float s1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
            r.m32 = s1 - t2.m32;
        }
        
        public static void Multiply(float s1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
            r.m32 = s1 * t2.m32;
        }
        
        public static void Divide(float s1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
            r.m32 = s1 / t2.m32;
        }
        
        public static void Modulo(float s1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
            r.m32 = s1 % t2.m32;
        }
        
        public static void Add(ref mat4x3 t1, float s2, out mat4x3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
            r.m32 = t1.m32 + s2;
        }
        
        public static void Subtract(ref mat4x3 t1, float s2, out mat4x3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
            r.m32 = t1.m32 - s2;
        }
        
        public static void Multiply(ref mat4x3 t1, float s2, out mat4x3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
            r.m32 = t1.m32 * s2;
        }
        
        public static void Divide(ref mat4x3 t1, float s2, out mat4x3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
            r.m32 = t1.m32 / s2;
        }
        
        public static void Modulo(ref mat4x3 t1, float s2, out mat4x3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
            r.m32 = t1.m32 % s2;
        }
        
        public static void Add(ref mat4x3 t1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
            r.m32 = t1.m32 + t2.m32;
        }
        
        public static void Subtract(ref mat4x3 t1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
            r.m32 = t1.m32 - t2.m32;
        }
        
        public static void Multiply(ref mat4x3 t1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
            r.m32 = t1.m32 * t2.m32;
        }
        
        public static void Divide(ref mat4x3 t1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
            r.m32 = t1.m32 / t2.m32;
        }
        
        public static void Modulo(ref mat4x3 t1, ref mat4x3 t2, out mat4x3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
            r.m32 = t1.m32 % t2.m32;
        }
        
        public static void Equal(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
            r.m32 = t1.m32 == t2.m32;
        }
        
        public static void GreaterThan(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
            r.m32 = t1.m32 > t2.m32;
        }
        
        public static void GreaterThanEqual(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
            r.m32 = t1.m32 >= t2.m32;
        }
        
        public static void LessThan(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
            r.m32 = t1.m32 < t2.m32;
        }
        
        public static void LessThanEqual(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
            r.m32 = t1.m32 <= t2.m32;
        }
        
        public static void NotEqual(ref mat4x3 t1, ref mat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
            r.m32 = t1.m32 != t2.m32;
        }
        
        public static void UnaryPlus(ref mat4 t, out mat4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m23 = +t.m23;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
            r.m32 = +t.m32;
            r.m33 = +t.m33;
        }
        
        public static void Negate(ref mat4 t, out mat4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m23 = -t.m23;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
            r.m32 = -t.m32;
            r.m33 = -t.m33;
        }
        
        public static void Increment(ref mat4 t, out mat4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m23 = ++t.m23;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
            r.m32 = ++t.m32;
            r.m33 = ++t.m33;
        }
        
        public static void Decrement(ref mat4 t, out mat4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m23 = --t.m23;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
            r.m32 = --t.m32;
            r.m33 = --t.m33;
        }
        
        public static void Add(float s1, ref mat4 t2, out mat4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m23 = s1 + t2.m23;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
            r.m32 = s1 + t2.m32;
            r.m33 = s1 + t2.m33;
        }
        
        public static void Subtract(float s1, ref mat4 t2, out mat4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m23 = s1 - t2.m23;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
            r.m32 = s1 - t2.m32;
            r.m33 = s1 - t2.m33;
        }
        
        public static void Multiply(float s1, ref mat4 t2, out mat4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m23 = s1 * t2.m23;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
            r.m32 = s1 * t2.m32;
            r.m33 = s1 * t2.m33;
        }
        
        public static void Divide(float s1, ref mat4 t2, out mat4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m23 = s1 / t2.m23;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
            r.m32 = s1 / t2.m32;
            r.m33 = s1 / t2.m33;
        }
        
        public static void Modulo(float s1, ref mat4 t2, out mat4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m23 = s1 % t2.m23;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
            r.m32 = s1 % t2.m32;
            r.m33 = s1 % t2.m33;
        }
        
        public static void Add(ref mat4 t1, float s2, out mat4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m23 = t1.m23 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
            r.m32 = t1.m32 + s2;
            r.m33 = t1.m33 + s2;
        }
        
        public static void Subtract(ref mat4 t1, float s2, out mat4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m23 = t1.m23 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
            r.m32 = t1.m32 - s2;
            r.m33 = t1.m33 - s2;
        }
        
        public static void Multiply(ref mat4 t1, float s2, out mat4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m23 = t1.m23 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
            r.m32 = t1.m32 * s2;
            r.m33 = t1.m33 * s2;
        }
        
        public static void Divide(ref mat4 t1, float s2, out mat4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m23 = t1.m23 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
            r.m32 = t1.m32 / s2;
            r.m33 = t1.m33 / s2;
        }
        
        public static void Modulo(ref mat4 t1, float s2, out mat4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m23 = t1.m23 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
            r.m32 = t1.m32 % s2;
            r.m33 = t1.m33 % s2;
        }
        
        public static void Add(ref mat4 t1, ref mat4 t2, out mat4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m23 = t1.m23 + t2.m23;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
            r.m32 = t1.m32 + t2.m32;
            r.m33 = t1.m33 + t2.m33;
        }
        
        public static void Subtract(ref mat4 t1, ref mat4 t2, out mat4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m23 = t1.m23 - t2.m23;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
            r.m32 = t1.m32 - t2.m32;
            r.m33 = t1.m33 - t2.m33;
        }
        
        public static void Multiply(ref mat4 t1, ref mat4 t2, out mat4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m23 = t1.m23 * t2.m23;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
            r.m32 = t1.m32 * t2.m32;
            r.m33 = t1.m33 * t2.m33;
        }
        
        public static void Divide(ref mat4 t1, ref mat4 t2, out mat4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m23 = t1.m23 / t2.m23;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
            r.m32 = t1.m32 / t2.m32;
            r.m33 = t1.m33 / t2.m33;
        }
        
        public static void Modulo(ref mat4 t1, ref mat4 t2, out mat4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m23 = t1.m23 % t2.m23;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
            r.m32 = t1.m32 % t2.m32;
            r.m33 = t1.m33 % t2.m33;
        }
        
        public static void Equal(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m23 = t1.m23 == t2.m23;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
            r.m32 = t1.m32 == t2.m32;
            r.m33 = t1.m33 == t2.m33;
        }
        
        public static void GreaterThan(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m23 = t1.m23 > t2.m23;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
            r.m32 = t1.m32 > t2.m32;
            r.m33 = t1.m33 > t2.m33;
        }
        
        public static void GreaterThanEqual(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m23 = t1.m23 >= t2.m23;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
            r.m32 = t1.m32 >= t2.m32;
            r.m33 = t1.m33 >= t2.m33;
        }
        
        public static void LessThan(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m23 = t1.m23 < t2.m23;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
            r.m32 = t1.m32 < t2.m32;
            r.m33 = t1.m33 < t2.m33;
        }
        
        public static void LessThanEqual(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m23 = t1.m23 <= t2.m23;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
            r.m32 = t1.m32 <= t2.m32;
            r.m33 = t1.m33 <= t2.m33;
        }
        
        public static void NotEqual(ref mat4 t1, ref mat4 t2, out bmat4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m23 = t1.m23 != t2.m23;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
            r.m32 = t1.m32 != t2.m32;
            r.m33 = t1.m33 != t2.m33;
        }
    }
}
