#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static void UnaryPlus(ref vec2 t, out vec2 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
        }
        
        public static void Negate(ref vec2 t, out vec2 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
        }
        
        public static void Increment(ref vec2 t, out vec2 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
        }
        
        public static void Decrement(ref vec2 t, out vec2 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
        }
        
        public static void Add(float s1, ref vec2 t2, out vec2 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
        }
        
        public static void Subtract(float s1, ref vec2 t2, out vec2 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
        }
        
        public static void Multiply(float s1, ref vec2 t2, out vec2 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
        }
        
        public static void Divide(float s1, ref vec2 t2, out vec2 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
        }
        
        public static void Modulo(float s1, ref vec2 t2, out vec2 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
        }
        
        public static void Add(ref vec2 t1, float s2, out vec2 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
        }
        
        public static void Subtract(ref vec2 t1, float s2, out vec2 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
        }
        
        public static void Multiply(ref vec2 t1, float s2, out vec2 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
        }
        
        public static void Divide(ref vec2 t1, float s2, out vec2 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
        }
        
        public static void Modulo(ref vec2 t1, float s2, out vec2 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
        }
        
        public static void Add(ref vec2 t1, ref vec2 t2, out vec2 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
        }
        
        public static void Subtract(ref vec2 t1, ref vec2 t2, out vec2 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
        }
        
        public static void Multiply(ref vec2 t1, ref vec2 t2, out vec2 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
        }
        
        public static void Divide(ref vec2 t1, ref vec2 t2, out vec2 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
        }
        
        public static void Modulo(ref vec2 t1, ref vec2 t2, out vec2 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
        }
        
        public static void Equal(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
        }
        
        public static void GreaterThan(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
        }
        
        public static void GreaterThanEqual(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
        }
        
        public static void LessThan(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
        }
        
        public static void LessThanEqual(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
        }
        
        public static void NotEqual(ref vec2 t1, ref vec2 t2, out bvec2 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
        }
        
        public static void UnaryPlus(ref vec3 t, out vec3 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
            r.v2 = +t.v2;
        }
        
        public static void Negate(ref vec3 t, out vec3 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
            r.v2 = -t.v2;
        }
        
        public static void Increment(ref vec3 t, out vec3 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
            r.v2 = ++t.v2;
        }
        
        public static void Decrement(ref vec3 t, out vec3 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
            r.v2 = --t.v2;
        }
        
        public static void Add(float s1, ref vec3 t2, out vec3 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
            r.v2 = s1 + t2.v2;
        }
        
        public static void Subtract(float s1, ref vec3 t2, out vec3 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
            r.v2 = s1 - t2.v2;
        }
        
        public static void Multiply(float s1, ref vec3 t2, out vec3 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
            r.v2 = s1 * t2.v2;
        }
        
        public static void Divide(float s1, ref vec3 t2, out vec3 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
            r.v2 = s1 / t2.v2;
        }
        
        public static void Modulo(float s1, ref vec3 t2, out vec3 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
            r.v2 = s1 % t2.v2;
        }
        
        public static void Add(ref vec3 t1, float s2, out vec3 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
            r.v2 = t1.v2 + s2;
        }
        
        public static void Subtract(ref vec3 t1, float s2, out vec3 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
            r.v2 = t1.v2 - s2;
        }
        
        public static void Multiply(ref vec3 t1, float s2, out vec3 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
            r.v2 = t1.v2 * s2;
        }
        
        public static void Divide(ref vec3 t1, float s2, out vec3 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
            r.v2 = t1.v2 / s2;
        }
        
        public static void Modulo(ref vec3 t1, float s2, out vec3 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
            r.v2 = t1.v2 % s2;
        }
        
        public static void Add(ref vec3 t1, ref vec3 t2, out vec3 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
            r.v2 = t1.v2 + t2.v2;
        }
        
        public static void Subtract(ref vec3 t1, ref vec3 t2, out vec3 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
            r.v2 = t1.v2 - t2.v2;
        }
        
        public static void Multiply(ref vec3 t1, ref vec3 t2, out vec3 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
            r.v2 = t1.v2 * t2.v2;
        }
        
        public static void Divide(ref vec3 t1, ref vec3 t2, out vec3 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
            r.v2 = t1.v2 / t2.v2;
        }
        
        public static void Modulo(ref vec3 t1, ref vec3 t2, out vec3 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
            r.v2 = t1.v2 % t2.v2;
        }
        
        public static void Equal(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
            r.v2 = t1.v2 == t2.v2;
        }
        
        public static void GreaterThan(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
            r.v2 = t1.v2 > t2.v2;
        }
        
        public static void GreaterThanEqual(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
            r.v2 = t1.v2 >= t2.v2;
        }
        
        public static void LessThan(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
            r.v2 = t1.v2 < t2.v2;
        }
        
        public static void LessThanEqual(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
            r.v2 = t1.v2 <= t2.v2;
        }
        
        public static void NotEqual(ref vec3 t1, ref vec3 t2, out bvec3 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
            r.v2 = t1.v2 != t2.v2;
        }
        
        public static void UnaryPlus(ref vec4 t, out vec4 r) {
            r.v0 = +t.v0;
            r.v1 = +t.v1;
            r.v2 = +t.v2;
            r.v3 = +t.v3;
        }
        
        public static void Negate(ref vec4 t, out vec4 r) {
            r.v0 = -t.v0;
            r.v1 = -t.v1;
            r.v2 = -t.v2;
            r.v3 = -t.v3;
        }
        
        public static void Increment(ref vec4 t, out vec4 r) {
            r.v0 = ++t.v0;
            r.v1 = ++t.v1;
            r.v2 = ++t.v2;
            r.v3 = ++t.v3;
        }
        
        public static void Decrement(ref vec4 t, out vec4 r) {
            r.v0 = --t.v0;
            r.v1 = --t.v1;
            r.v2 = --t.v2;
            r.v3 = --t.v3;
        }
        
        public static void Add(float s1, ref vec4 t2, out vec4 r) {
            r.v0 = s1 + t2.v0;
            r.v1 = s1 + t2.v1;
            r.v2 = s1 + t2.v2;
            r.v3 = s1 + t2.v3;
        }
        
        public static void Subtract(float s1, ref vec4 t2, out vec4 r) {
            r.v0 = s1 - t2.v0;
            r.v1 = s1 - t2.v1;
            r.v2 = s1 - t2.v2;
            r.v3 = s1 - t2.v3;
        }
        
        public static void Multiply(float s1, ref vec4 t2, out vec4 r) {
            r.v0 = s1 * t2.v0;
            r.v1 = s1 * t2.v1;
            r.v2 = s1 * t2.v2;
            r.v3 = s1 * t2.v3;
        }
        
        public static void Divide(float s1, ref vec4 t2, out vec4 r) {
            r.v0 = s1 / t2.v0;
            r.v1 = s1 / t2.v1;
            r.v2 = s1 / t2.v2;
            r.v3 = s1 / t2.v3;
        }
        
        public static void Modulo(float s1, ref vec4 t2, out vec4 r) {
            r.v0 = s1 % t2.v0;
            r.v1 = s1 % t2.v1;
            r.v2 = s1 % t2.v2;
            r.v3 = s1 % t2.v3;
        }
        
        public static void Add(ref vec4 t1, float s2, out vec4 r) {
            r.v0 = t1.v0 + s2;
            r.v1 = t1.v1 + s2;
            r.v2 = t1.v2 + s2;
            r.v3 = t1.v3 + s2;
        }
        
        public static void Subtract(ref vec4 t1, float s2, out vec4 r) {
            r.v0 = t1.v0 - s2;
            r.v1 = t1.v1 - s2;
            r.v2 = t1.v2 - s2;
            r.v3 = t1.v3 - s2;
        }
        
        public static void Multiply(ref vec4 t1, float s2, out vec4 r) {
            r.v0 = t1.v0 * s2;
            r.v1 = t1.v1 * s2;
            r.v2 = t1.v2 * s2;
            r.v3 = t1.v3 * s2;
        }
        
        public static void Divide(ref vec4 t1, float s2, out vec4 r) {
            r.v0 = t1.v0 / s2;
            r.v1 = t1.v1 / s2;
            r.v2 = t1.v2 / s2;
            r.v3 = t1.v3 / s2;
        }
        
        public static void Modulo(ref vec4 t1, float s2, out vec4 r) {
            r.v0 = t1.v0 % s2;
            r.v1 = t1.v1 % s2;
            r.v2 = t1.v2 % s2;
            r.v3 = t1.v3 % s2;
        }
        
        public static void Add(ref vec4 t1, ref vec4 t2, out vec4 r) {
            r.v0 = t1.v0 + t2.v0;
            r.v1 = t1.v1 + t2.v1;
            r.v2 = t1.v2 + t2.v2;
            r.v3 = t1.v3 + t2.v3;
        }
        
        public static void Subtract(ref vec4 t1, ref vec4 t2, out vec4 r) {
            r.v0 = t1.v0 - t2.v0;
            r.v1 = t1.v1 - t2.v1;
            r.v2 = t1.v2 - t2.v2;
            r.v3 = t1.v3 - t2.v3;
        }
        
        public static void Multiply(ref vec4 t1, ref vec4 t2, out vec4 r) {
            r.v0 = t1.v0 * t2.v0;
            r.v1 = t1.v1 * t2.v1;
            r.v2 = t1.v2 * t2.v2;
            r.v3 = t1.v3 * t2.v3;
        }
        
        public static void Divide(ref vec4 t1, ref vec4 t2, out vec4 r) {
            r.v0 = t1.v0 / t2.v0;
            r.v1 = t1.v1 / t2.v1;
            r.v2 = t1.v2 / t2.v2;
            r.v3 = t1.v3 / t2.v3;
        }
        
        public static void Modulo(ref vec4 t1, ref vec4 t2, out vec4 r) {
            r.v0 = t1.v0 % t2.v0;
            r.v1 = t1.v1 % t2.v1;
            r.v2 = t1.v2 % t2.v2;
            r.v3 = t1.v3 % t2.v3;
        }
        
        public static void Equal(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 == t2.v0;
            r.v1 = t1.v1 == t2.v1;
            r.v2 = t1.v2 == t2.v2;
            r.v3 = t1.v3 == t2.v3;
        }
        
        public static void GreaterThan(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 > t2.v0;
            r.v1 = t1.v1 > t2.v1;
            r.v2 = t1.v2 > t2.v2;
            r.v3 = t1.v3 > t2.v3;
        }
        
        public static void GreaterThanEqual(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 >= t2.v0;
            r.v1 = t1.v1 >= t2.v1;
            r.v2 = t1.v2 >= t2.v2;
            r.v3 = t1.v3 >= t2.v3;
        }
        
        public static void LessThan(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 < t2.v0;
            r.v1 = t1.v1 < t2.v1;
            r.v2 = t1.v2 < t2.v2;
            r.v3 = t1.v3 < t2.v3;
        }
        
        public static void LessThanEqual(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 <= t2.v0;
            r.v1 = t1.v1 <= t2.v1;
            r.v2 = t1.v2 <= t2.v2;
            r.v3 = t1.v3 <= t2.v3;
        }
        
        public static void NotEqual(ref vec4 t1, ref vec4 t2, out bvec4 r) {
            r.v0 = t1.v0 != t2.v0;
            r.v1 = t1.v1 != t2.v1;
            r.v2 = t1.v2 != t2.v2;
            r.v3 = t1.v3 != t2.v3;
        }
    }
}
