#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class bmath {
        
        public static bool All(bmat2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11;
        }
        
        public static bool All(ref bmat2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11;
        }
        
        public static bool Any(bmat2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11;
        }
        
        public static bool Any(ref bmat2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11;
        }
        
        public static bool All(bmat2x3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12;
        }
        
        public static bool All(ref bmat2x3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12;
        }
        
        public static bool Any(bmat2x3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12;
        }
        
        public static bool Any(ref bmat2x3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12;
        }
        
        public static bool All(bmat2x4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13;
        }
        
        public static bool All(ref bmat2x4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13;
        }
        
        public static bool Any(bmat2x4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13;
        }
        
        public static bool Any(ref bmat2x4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13;
        }
        
        public static bool All(bmat3x2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11 && v.m20 && v.m21;
        }
        
        public static bool All(ref bmat3x2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11 && v.m20 && v.m21;
        }
        
        public static bool Any(bmat3x2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11 || v.m20 || v.m21;
        }
        
        public static bool Any(ref bmat3x2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11 || v.m20 || v.m21;
        }
        
        public static bool All(bmat3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12 && v.m20 && v.m21 && v.m22;
        }
        
        public static bool All(ref bmat3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12 && v.m20 && v.m21 && v.m22;
        }
        
        public static bool Any(bmat3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12 || v.m20 || v.m21 || v.m22;
        }
        
        public static bool Any(ref bmat3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12 || v.m20 || v.m21 || v.m22;
        }
        
        public static bool All(bmat3x4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13 && v.m20 && v.m21 && v.m22 && v.m23;
        }
        
        public static bool All(ref bmat3x4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13 && v.m20 && v.m21 && v.m22 && v.m23;
        }
        
        public static bool Any(bmat3x4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13 || v.m20 || v.m21 || v.m22 || v.m23;
        }
        
        public static bool Any(ref bmat3x4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13 || v.m20 || v.m21 || v.m22 || v.m23;
        }
        
        public static bool All(bmat4x2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11 && v.m20 && v.m21 && v.m30 && v.m31;
        }
        
        public static bool All(ref bmat4x2 v) {
            return v.m00 && v.m01 && v.m10 && v.m11 && v.m20 && v.m21 && v.m30 && v.m31;
        }
        
        public static bool Any(bmat4x2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11 || v.m20 || v.m21 || v.m30 || v.m31;
        }
        
        public static bool Any(ref bmat4x2 v) {
            return v.m00 || v.m01 || v.m10 || v.m11 || v.m20 || v.m21 || v.m30 || v.m31;
        }
        
        public static bool All(bmat4x3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12 && v.m20 && v.m21 && v.m22 && v.m30 && v.m31 && v.m32;
        }
        
        public static bool All(ref bmat4x3 v) {
            return v.m00 && v.m01 && v.m02 && v.m10 && v.m11 && v.m12 && v.m20 && v.m21 && v.m22 && v.m30 && v.m31 && v.m32;
        }
        
        public static bool Any(bmat4x3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12 || v.m20 || v.m21 || v.m22 || v.m30 || v.m31 || v.m32;
        }
        
        public static bool Any(ref bmat4x3 v) {
            return v.m00 || v.m01 || v.m02 || v.m10 || v.m11 || v.m12 || v.m20 || v.m21 || v.m22 || v.m30 || v.m31 || v.m32;
        }
        
        public static bool All(bmat4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13 && v.m20 && v.m21 && v.m22 && v.m23 && v.m30 && v.m31 && v.m32 && v.m33;
        }
        
        public static bool All(ref bmat4 v) {
            return v.m00 && v.m01 && v.m02 && v.m03 && v.m10 && v.m11 && v.m12 && v.m13 && v.m20 && v.m21 && v.m22 && v.m23 && v.m30 && v.m31 && v.m32 && v.m33;
        }
        
        public static bool Any(bmat4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13 || v.m20 || v.m21 || v.m22 || v.m23 || v.m30 || v.m31 || v.m32 || v.m33;
        }
        
        public static bool Any(ref bmat4 v) {
            return v.m00 || v.m01 || v.m02 || v.m03 || v.m10 || v.m11 || v.m12 || v.m13 || v.m20 || v.m21 || v.m22 || v.m23 || v.m30 || v.m31 || v.m32 || v.m33;
        }
    }
}
