#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class bmath {
        
        public static bmat2 Transpose(bmat2 t0) {
            return new bmat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static bmat2 Transpose(ref bmat2 t0) {
            return new bmat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static bool Minor(bmat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static bool Minor(ref bmat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static bmat3x2 Transpose(bmat2x3 t0) {
            return new bmat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static bmat3x2 Transpose(ref bmat2x3 t0) {
            return new bmat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static bvec2 Minor(bmat2x3 t0, int i0, int i1) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bvec2 Minor(ref bmat2x3 t0, int i0, int i1) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bmat4x2 Transpose(bmat2x4 t0) {
            return new bmat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static bmat4x2 Transpose(ref bmat2x4 t0) {
            return new bmat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static bvec3 Minor(bmat2x4 t0, int i0, int i1) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static bvec3 Minor(ref bmat2x4 t0, int i0, int i1) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static bmat2x3 Transpose(bmat3x2 t0) {
            return new bmat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static bmat2x3 Transpose(ref bmat3x2 t0) {
            return new bmat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static bvec2 Minor(bmat3x2 t0, int i0, int i1) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static bvec2 Minor(ref bmat3x2 t0, int i0, int i1) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static bmat3 Transpose(bmat3 t0) {
            return new bmat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static bmat3 Transpose(ref bmat3 t0) {
            return new bmat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static bmat2 Minor(bmat3 t0, int i0, int i1) {
            return new bmat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bmat2 Minor(ref bmat3 t0, int i0, int i1) {
            return new bmat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bmat4x3 Transpose(bmat3x4 t0) {
            return new bmat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static bmat4x3 Transpose(ref bmat3x4 t0) {
            return new bmat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static bmat2x3 Minor(bmat3x4 t0, int i0, int i1) {
            return new bmat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static bmat2x3 Minor(ref bmat3x4 t0, int i0, int i1) {
            return new bmat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static bmat2x4 Transpose(bmat4x2 t0) {
            return new bmat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static bmat2x4 Transpose(ref bmat4x2 t0) {
            return new bmat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static bvec3 Minor(bmat4x2 t0, int i0, int i1) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static bvec3 Minor(ref bmat4x2 t0, int i0, int i1) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static bmat3x4 Transpose(bmat4x3 t0) {
            return new bmat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static bmat3x4 Transpose(ref bmat4x3 t0) {
            return new bmat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static bmat3x2 Minor(bmat4x3 t0, int i0, int i1) {
            return new bmat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bmat3x2 Minor(ref bmat4x3 t0, int i0, int i1) {
            return new bmat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static bmat4 Transpose(bmat4 t0) {
            return new bmat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static bmat4 Transpose(ref bmat4 t0) {
            return new bmat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static bmat3 Minor(bmat4 t0, int i0, int i1) {
            return new bmat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static bmat3 Minor(ref bmat4 t0, int i0, int i1) {
            return new bmat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
    }
}
