#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class bmath {
        
        public static bvec2 Transpose(bvec2 t0) {
            return new bvec2(t0.v0, t0.v1);
        }
        
        public static bvec2 Transpose(ref bvec2 t0) {
            return new bvec2(t0.v0, t0.v1);
        }
        
        public static bool Minor(bvec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static bool Minor(ref bvec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static bvec3 Transpose(bvec3 t0) {
            return new bvec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static bvec3 Transpose(ref bvec3 t0) {
            return new bvec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static bvec2 Minor(bvec3 t0, int i0) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static bvec2 Minor(ref bvec3 t0, int i0) {
            return new bvec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static bvec4 Transpose(bvec4 t0) {
            return new bvec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static bvec4 Transpose(ref bvec4 t0) {
            return new bvec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static bvec3 Minor(bvec4 t0, int i0) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static bvec3 Minor(ref bvec4 t0, int i0) {
            return new bvec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
    }
}
