#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class dmath {
        
        public static dvec2 InnerProduct1(dmat2 t0, dvec2 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static dvec2 InnerProduct1(ref dmat2 t0, ref dvec2 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static dmat2 InnerProduct1(dmat2 t0, dmat2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static dmat2 InnerProduct1(ref dmat2 t0, ref dmat2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static dmat2x3 InnerProduct1(dmat2 t0, dmat2x3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static dmat2x3 InnerProduct1(ref dmat2 t0, ref dmat2x3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static dmat2x4 InnerProduct1(dmat2 t0, dmat2x4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static dmat2x4 InnerProduct1(ref dmat2 t0, ref dmat2x4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static double InnerProduct2(dmat2 t0, dmat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static double InnerProduct2(ref dmat2 t0, ref dmat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static dmat2 Transpose(dmat2 t0) {
            return new dmat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static dmat2 Transpose(ref dmat2 t0) {
            return new dmat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static double Minor(dmat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static double Minor(ref dmat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static double MagnitudeSquared(dmat2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec2 InnerProduct1(dmat2x3 t0, dvec3 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static dvec2 InnerProduct1(ref dmat2x3 t0, ref dvec3 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static dmat2 InnerProduct1(dmat2x3 t0, dmat3x2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static dmat2 InnerProduct1(ref dmat2x3 t0, ref dmat3x2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static dmat2x3 InnerProduct1(dmat2x3 t0, dmat3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static dmat2x3 InnerProduct1(ref dmat2x3 t0, ref dmat3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static dmat2x4 InnerProduct1(dmat2x3 t0, dmat3x4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static dmat2x4 InnerProduct1(ref dmat2x3 t0, ref dmat3x4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static double InnerProduct2(dmat2x3 t0, dmat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static double InnerProduct2(ref dmat2x3 t0, ref dmat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static dmat3x2 Transpose(dmat2x3 t0) {
            return new dmat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static dmat3x2 Transpose(ref dmat2x3 t0) {
            return new dmat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static dvec2 Minor(dmat2x3 t0, int i0, int i1) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static dvec2 Minor(ref dmat2x3 t0, int i0, int i1) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static double MagnitudeSquared(dmat2x3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat2x3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat2x3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat2x3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec2 InnerProduct1(dmat2x4 t0, dvec4 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static dvec2 InnerProduct1(ref dmat2x4 t0, ref dvec4 t1) {
            return new dvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static dmat2 InnerProduct1(dmat2x4 t0, dmat4x2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static dmat2 InnerProduct1(ref dmat2x4 t0, ref dmat4x2 t1) {
            return new dmat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static dmat2x3 InnerProduct1(dmat2x4 t0, dmat4x3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static dmat2x3 InnerProduct1(ref dmat2x4 t0, ref dmat4x3 t1) {
            return new dmat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static dmat2x4 InnerProduct1(dmat2x4 t0, dmat4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static dmat2x4 InnerProduct1(ref dmat2x4 t0, ref dmat4 t1) {
            return new dmat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static double InnerProduct2(dmat2x4 t0, dmat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static double InnerProduct2(ref dmat2x4 t0, ref dmat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static dmat4x2 Transpose(dmat2x4 t0) {
            return new dmat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static dmat4x2 Transpose(ref dmat2x4 t0) {
            return new dmat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static dvec3 Minor(dmat2x4 t0, int i0, int i1) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static dvec3 Minor(ref dmat2x4 t0, int i0, int i1) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static double MagnitudeSquared(dmat2x4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat2x4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat2x4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat2x4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec3 InnerProduct1(dmat3x2 t0, dvec2 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static dvec3 InnerProduct1(ref dmat3x2 t0, ref dvec2 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static dmat3x2 InnerProduct1(dmat3x2 t0, dmat2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static dmat3x2 InnerProduct1(ref dmat3x2 t0, ref dmat2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static dmat3 InnerProduct1(dmat3x2 t0, dmat2x3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static dmat3 InnerProduct1(ref dmat3x2 t0, ref dmat2x3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static dmat3x4 InnerProduct1(dmat3x2 t0, dmat2x4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static dmat3x4 InnerProduct1(ref dmat3x2 t0, ref dmat2x4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static double InnerProduct2(dmat3x2 t0, dmat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static double InnerProduct2(ref dmat3x2 t0, ref dmat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static dmat2x3 Transpose(dmat3x2 t0) {
            return new dmat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static dmat2x3 Transpose(ref dmat3x2 t0) {
            return new dmat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static dvec2 Minor(dmat3x2 t0, int i0, int i1) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static dvec2 Minor(ref dmat3x2 t0, int i0, int i1) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static double MagnitudeSquared(dmat3x2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat3x2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat3x2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat3x2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec3 InnerProduct1(dmat3 t0, dvec3 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static dvec3 InnerProduct1(ref dmat3 t0, ref dvec3 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static dmat3x2 InnerProduct1(dmat3 t0, dmat3x2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static dmat3x2 InnerProduct1(ref dmat3 t0, ref dmat3x2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static dmat3 InnerProduct1(dmat3 t0, dmat3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static dmat3 InnerProduct1(ref dmat3 t0, ref dmat3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static dmat3x4 InnerProduct1(dmat3 t0, dmat3x4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static dmat3x4 InnerProduct1(ref dmat3 t0, ref dmat3x4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static double InnerProduct2(dmat3 t0, dmat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static double InnerProduct2(ref dmat3 t0, ref dmat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static dmat3 Transpose(dmat3 t0) {
            return new dmat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static dmat3 Transpose(ref dmat3 t0) {
            return new dmat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static dmat2 Minor(dmat3 t0, int i0, int i1) {
            return new dmat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static dmat2 Minor(ref dmat3 t0, int i0, int i1) {
            return new dmat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static double MagnitudeSquared(dmat3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec3 InnerProduct1(dmat3x4 t0, dvec4 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static dvec3 InnerProduct1(ref dmat3x4 t0, ref dvec4 t1) {
            return new dvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static dmat3x2 InnerProduct1(dmat3x4 t0, dmat4x2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static dmat3x2 InnerProduct1(ref dmat3x4 t0, ref dmat4x2 t1) {
            return new dmat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static dmat3 InnerProduct1(dmat3x4 t0, dmat4x3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static dmat3 InnerProduct1(ref dmat3x4 t0, ref dmat4x3 t1) {
            return new dmat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static dmat3x4 InnerProduct1(dmat3x4 t0, dmat4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static dmat3x4 InnerProduct1(ref dmat3x4 t0, ref dmat4 t1) {
            return new dmat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static double InnerProduct2(dmat3x4 t0, dmat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static double InnerProduct2(ref dmat3x4 t0, ref dmat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static dmat4x3 Transpose(dmat3x4 t0) {
            return new dmat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static dmat4x3 Transpose(ref dmat3x4 t0) {
            return new dmat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static dmat2x3 Minor(dmat3x4 t0, int i0, int i1) {
            return new dmat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static dmat2x3 Minor(ref dmat3x4 t0, int i0, int i1) {
            return new dmat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static double MagnitudeSquared(dmat3x4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat3x4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat3x4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat3x4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec4 InnerProduct1(dmat4x2 t0, dvec2 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static dvec4 InnerProduct1(ref dmat4x2 t0, ref dvec2 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static dmat4x2 InnerProduct1(dmat4x2 t0, dmat2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static dmat4x2 InnerProduct1(ref dmat4x2 t0, ref dmat2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static dmat4x3 InnerProduct1(dmat4x2 t0, dmat2x3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static dmat4x3 InnerProduct1(ref dmat4x2 t0, ref dmat2x3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static dmat4 InnerProduct1(dmat4x2 t0, dmat2x4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static dmat4 InnerProduct1(ref dmat4x2 t0, ref dmat2x4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static double InnerProduct2(dmat4x2 t0, dmat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static double InnerProduct2(ref dmat4x2 t0, ref dmat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static dmat2x4 Transpose(dmat4x2 t0) {
            return new dmat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static dmat2x4 Transpose(ref dmat4x2 t0) {
            return new dmat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static dvec3 Minor(dmat4x2 t0, int i0, int i1) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static dvec3 Minor(ref dmat4x2 t0, int i0, int i1) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static double MagnitudeSquared(dmat4x2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat4x2 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat4x2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat4x2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec4 InnerProduct1(dmat4x3 t0, dvec3 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static dvec4 InnerProduct1(ref dmat4x3 t0, ref dvec3 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static dmat4x2 InnerProduct1(dmat4x3 t0, dmat3x2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static dmat4x2 InnerProduct1(ref dmat4x3 t0, ref dmat3x2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static dmat4x3 InnerProduct1(dmat4x3 t0, dmat3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static dmat4x3 InnerProduct1(ref dmat4x3 t0, ref dmat3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static dmat4 InnerProduct1(dmat4x3 t0, dmat3x4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static dmat4 InnerProduct1(ref dmat4x3 t0, ref dmat3x4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static double InnerProduct2(dmat4x3 t0, dmat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static double InnerProduct2(ref dmat4x3 t0, ref dmat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static dmat3x4 Transpose(dmat4x3 t0) {
            return new dmat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static dmat3x4 Transpose(ref dmat4x3 t0) {
            return new dmat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static dmat3x2 Minor(dmat4x3 t0, int i0, int i1) {
            return new dmat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static dmat3x2 Minor(ref dmat4x3 t0, int i0, int i1) {
            return new dmat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static double MagnitudeSquared(dmat4x3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat4x3 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat4x3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat4x3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static dvec4 InnerProduct1(dmat4 t0, dvec4 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static dvec4 InnerProduct1(ref dmat4 t0, ref dvec4 t1) {
            return new dvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static dmat4x2 InnerProduct1(dmat4 t0, dmat4x2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static dmat4x2 InnerProduct1(ref dmat4 t0, ref dmat4x2 t1) {
            return new dmat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static dmat4x3 InnerProduct1(dmat4 t0, dmat4x3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static dmat4x3 InnerProduct1(ref dmat4 t0, ref dmat4x3 t1) {
            return new dmat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static dmat4 InnerProduct1(dmat4 t0, dmat4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static dmat4 InnerProduct1(ref dmat4 t0, ref dmat4 t1) {
            return new dmat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static double InnerProduct2(dmat4 t0, dmat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static double InnerProduct2(ref dmat4 t0, ref dmat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static dmat4 Transpose(dmat4 t0) {
            return new dmat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static dmat4 Transpose(ref dmat4 t0) {
            return new dmat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static dmat3 Minor(dmat4 t0, int i0, int i1) {
            return new dmat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static dmat3 Minor(ref dmat4 t0, int i0, int i1) {
            return new dmat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static double MagnitudeSquared(dmat4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dmat4 t0) {
            return dmath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(dmat4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dmat4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
    }
}
