#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class dmath {
        
        public static double InnerProduct1(dvec2 t0, dvec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static double InnerProduct1(ref dvec2 t0, ref dvec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static dvec2 InnerProduct1(dvec2 t0, dmat2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static dvec2 InnerProduct1(ref dvec2 t0, ref dmat2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static dvec3 InnerProduct1(dvec2 t0, dmat2x3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static dvec3 InnerProduct1(ref dvec2 t0, ref dmat2x3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static dvec4 InnerProduct1(dvec2 t0, dmat2x4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static dvec4 InnerProduct1(ref dvec2 t0, ref dmat2x4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static dmat2 OuterProduct(dvec2 t0, dvec2 t1) {
            return new dmat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static dmat2 OuterProduct(ref dvec2 t0, ref dvec2 t1) {
            return new dmat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static dmat3x2 OuterProduct(dvec2 t0, dvec3 t1) {
            return new dmat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static dmat3x2 OuterProduct(ref dvec2 t0, ref dvec3 t1) {
            return new dmat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static dmat4x2 OuterProduct(dvec2 t0, dvec4 t1) {
            return new dmat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static dmat4x2 OuterProduct(ref dvec2 t0, ref dvec4 t1) {
            return new dmat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static dvec2 Transpose(dvec2 t0) {
            return new dvec2(t0.v0, t0.v1);
        }
        
        public static dvec2 Transpose(ref dvec2 t0) {
            return new dvec2(t0.v0, t0.v1);
        }
        
        public static double Minor(dvec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static double Minor(ref dvec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static double MagnitudeSquared(dvec2 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dvec2 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(dvec2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dvec2 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double InnerProduct1(dvec3 t0, dvec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static double InnerProduct1(ref dvec3 t0, ref dvec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static dvec2 InnerProduct1(dvec3 t0, dmat3x2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static dvec2 InnerProduct1(ref dvec3 t0, ref dmat3x2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static dvec3 InnerProduct1(dvec3 t0, dmat3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static dvec3 InnerProduct1(ref dvec3 t0, ref dmat3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static dvec4 InnerProduct1(dvec3 t0, dmat3x4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static dvec4 InnerProduct1(ref dvec3 t0, ref dmat3x4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static dmat2x3 OuterProduct(dvec3 t0, dvec2 t1) {
            return new dmat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static dmat2x3 OuterProduct(ref dvec3 t0, ref dvec2 t1) {
            return new dmat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static dmat3 OuterProduct(dvec3 t0, dvec3 t1) {
            return new dmat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static dmat3 OuterProduct(ref dvec3 t0, ref dvec3 t1) {
            return new dmat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static dmat4x3 OuterProduct(dvec3 t0, dvec4 t1) {
            return new dmat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static dmat4x3 OuterProduct(ref dvec3 t0, ref dvec4 t1) {
            return new dmat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static dvec3 Transpose(dvec3 t0) {
            return new dvec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static dvec3 Transpose(ref dvec3 t0) {
            return new dvec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static dvec2 Minor(dvec3 t0, int i0) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static dvec2 Minor(ref dvec3 t0, int i0) {
            return new dvec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static double MagnitudeSquared(dvec3 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dvec3 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(dvec3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dvec3 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double InnerProduct1(dvec4 t0, dvec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static double InnerProduct1(ref dvec4 t0, ref dvec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static dvec2 InnerProduct1(dvec4 t0, dmat4x2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static dvec2 InnerProduct1(ref dvec4 t0, ref dmat4x2 t1) {
            return new dvec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static dvec3 InnerProduct1(dvec4 t0, dmat4x3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static dvec3 InnerProduct1(ref dvec4 t0, ref dmat4x3 t1) {
            return new dvec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static dvec4 InnerProduct1(dvec4 t0, dmat4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static dvec4 InnerProduct1(ref dvec4 t0, ref dmat4 t1) {
            return new dvec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static dmat2x4 OuterProduct(dvec4 t0, dvec2 t1) {
            return new dmat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static dmat2x4 OuterProduct(ref dvec4 t0, ref dvec2 t1) {
            return new dmat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static dmat3x4 OuterProduct(dvec4 t0, dvec3 t1) {
            return new dmat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static dmat3x4 OuterProduct(ref dvec4 t0, ref dvec3 t1) {
            return new dmat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static dmat4 OuterProduct(dvec4 t0, dvec4 t1) {
            return new dmat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static dmat4 OuterProduct(ref dvec4 t0, ref dvec4 t1) {
            return new dmat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static dvec4 Transpose(dvec4 t0) {
            return new dvec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static dvec4 Transpose(ref dvec4 t0) {
            return new dvec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static dvec3 Minor(dvec4 t0, int i0) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static dvec3 Minor(ref dvec4 t0, int i0) {
            return new dvec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static double MagnitudeSquared(dvec4 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double MagnitudeSquared(ref dvec4 t0) {
            return dmath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(dvec4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref dvec4 t) {
            return System.Math.Sqrt(dmath.MagnitudeSquared(ref t));
        }
    }
}
