#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class imath {
        
        public static ivec2 InnerProduct1(imat2 t0, ivec2 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static ivec2 InnerProduct1(ref imat2 t0, ref ivec2 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static imat2 InnerProduct1(imat2 t0, imat2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static imat2 InnerProduct1(ref imat2 t0, ref imat2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static imat2x3 InnerProduct1(imat2 t0, imat2x3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static imat2x3 InnerProduct1(ref imat2 t0, ref imat2x3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static imat2x4 InnerProduct1(imat2 t0, imat2x4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static imat2x4 InnerProduct1(ref imat2 t0, ref imat2x4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static int InnerProduct2(imat2 t0, imat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static int InnerProduct2(ref imat2 t0, ref imat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static imat2 Transpose(imat2 t0) {
            return new imat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static imat2 Transpose(ref imat2 t0) {
            return new imat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static int Minor(imat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static int Minor(ref imat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static int MagnitudeSquared(imat2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec2 InnerProduct1(imat2x3 t0, ivec3 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static ivec2 InnerProduct1(ref imat2x3 t0, ref ivec3 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static imat2 InnerProduct1(imat2x3 t0, imat3x2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static imat2 InnerProduct1(ref imat2x3 t0, ref imat3x2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static imat2x3 InnerProduct1(imat2x3 t0, imat3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static imat2x3 InnerProduct1(ref imat2x3 t0, ref imat3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static imat2x4 InnerProduct1(imat2x3 t0, imat3x4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static imat2x4 InnerProduct1(ref imat2x3 t0, ref imat3x4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static int InnerProduct2(imat2x3 t0, imat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static int InnerProduct2(ref imat2x3 t0, ref imat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static imat3x2 Transpose(imat2x3 t0) {
            return new imat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static imat3x2 Transpose(ref imat2x3 t0) {
            return new imat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static ivec2 Minor(imat2x3 t0, int i0, int i1) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static ivec2 Minor(ref imat2x3 t0, int i0, int i1) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static int MagnitudeSquared(imat2x3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat2x3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat2x3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat2x3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec2 InnerProduct1(imat2x4 t0, ivec4 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static ivec2 InnerProduct1(ref imat2x4 t0, ref ivec4 t1) {
            return new ivec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static imat2 InnerProduct1(imat2x4 t0, imat4x2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static imat2 InnerProduct1(ref imat2x4 t0, ref imat4x2 t1) {
            return new imat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static imat2x3 InnerProduct1(imat2x4 t0, imat4x3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static imat2x3 InnerProduct1(ref imat2x4 t0, ref imat4x3 t1) {
            return new imat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static imat2x4 InnerProduct1(imat2x4 t0, imat4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static imat2x4 InnerProduct1(ref imat2x4 t0, ref imat4 t1) {
            return new imat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static int InnerProduct2(imat2x4 t0, imat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static int InnerProduct2(ref imat2x4 t0, ref imat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static imat4x2 Transpose(imat2x4 t0) {
            return new imat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static imat4x2 Transpose(ref imat2x4 t0) {
            return new imat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static ivec3 Minor(imat2x4 t0, int i0, int i1) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static ivec3 Minor(ref imat2x4 t0, int i0, int i1) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static int MagnitudeSquared(imat2x4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat2x4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat2x4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat2x4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec3 InnerProduct1(imat3x2 t0, ivec2 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static ivec3 InnerProduct1(ref imat3x2 t0, ref ivec2 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static imat3x2 InnerProduct1(imat3x2 t0, imat2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static imat3x2 InnerProduct1(ref imat3x2 t0, ref imat2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static imat3 InnerProduct1(imat3x2 t0, imat2x3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static imat3 InnerProduct1(ref imat3x2 t0, ref imat2x3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static imat3x4 InnerProduct1(imat3x2 t0, imat2x4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static imat3x4 InnerProduct1(ref imat3x2 t0, ref imat2x4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static int InnerProduct2(imat3x2 t0, imat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static int InnerProduct2(ref imat3x2 t0, ref imat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static imat2x3 Transpose(imat3x2 t0) {
            return new imat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static imat2x3 Transpose(ref imat3x2 t0) {
            return new imat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static ivec2 Minor(imat3x2 t0, int i0, int i1) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static ivec2 Minor(ref imat3x2 t0, int i0, int i1) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static int MagnitudeSquared(imat3x2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat3x2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat3x2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat3x2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec3 InnerProduct1(imat3 t0, ivec3 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static ivec3 InnerProduct1(ref imat3 t0, ref ivec3 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static imat3x2 InnerProduct1(imat3 t0, imat3x2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static imat3x2 InnerProduct1(ref imat3 t0, ref imat3x2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static imat3 InnerProduct1(imat3 t0, imat3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static imat3 InnerProduct1(ref imat3 t0, ref imat3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static imat3x4 InnerProduct1(imat3 t0, imat3x4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static imat3x4 InnerProduct1(ref imat3 t0, ref imat3x4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static int InnerProduct2(imat3 t0, imat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static int InnerProduct2(ref imat3 t0, ref imat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static imat3 Transpose(imat3 t0) {
            return new imat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static imat3 Transpose(ref imat3 t0) {
            return new imat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static imat2 Minor(imat3 t0, int i0, int i1) {
            return new imat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static imat2 Minor(ref imat3 t0, int i0, int i1) {
            return new imat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static int MagnitudeSquared(imat3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec3 InnerProduct1(imat3x4 t0, ivec4 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static ivec3 InnerProduct1(ref imat3x4 t0, ref ivec4 t1) {
            return new ivec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static imat3x2 InnerProduct1(imat3x4 t0, imat4x2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static imat3x2 InnerProduct1(ref imat3x4 t0, ref imat4x2 t1) {
            return new imat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static imat3 InnerProduct1(imat3x4 t0, imat4x3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static imat3 InnerProduct1(ref imat3x4 t0, ref imat4x3 t1) {
            return new imat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static imat3x4 InnerProduct1(imat3x4 t0, imat4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static imat3x4 InnerProduct1(ref imat3x4 t0, ref imat4 t1) {
            return new imat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static int InnerProduct2(imat3x4 t0, imat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static int InnerProduct2(ref imat3x4 t0, ref imat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static imat4x3 Transpose(imat3x4 t0) {
            return new imat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static imat4x3 Transpose(ref imat3x4 t0) {
            return new imat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static imat2x3 Minor(imat3x4 t0, int i0, int i1) {
            return new imat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static imat2x3 Minor(ref imat3x4 t0, int i0, int i1) {
            return new imat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static int MagnitudeSquared(imat3x4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat3x4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat3x4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat3x4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec4 InnerProduct1(imat4x2 t0, ivec2 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static ivec4 InnerProduct1(ref imat4x2 t0, ref ivec2 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static imat4x2 InnerProduct1(imat4x2 t0, imat2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static imat4x2 InnerProduct1(ref imat4x2 t0, ref imat2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static imat4x3 InnerProduct1(imat4x2 t0, imat2x3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static imat4x3 InnerProduct1(ref imat4x2 t0, ref imat2x3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static imat4 InnerProduct1(imat4x2 t0, imat2x4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static imat4 InnerProduct1(ref imat4x2 t0, ref imat2x4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static int InnerProduct2(imat4x2 t0, imat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static int InnerProduct2(ref imat4x2 t0, ref imat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static imat2x4 Transpose(imat4x2 t0) {
            return new imat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static imat2x4 Transpose(ref imat4x2 t0) {
            return new imat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static ivec3 Minor(imat4x2 t0, int i0, int i1) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static ivec3 Minor(ref imat4x2 t0, int i0, int i1) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static int MagnitudeSquared(imat4x2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat4x2 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat4x2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat4x2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec4 InnerProduct1(imat4x3 t0, ivec3 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static ivec4 InnerProduct1(ref imat4x3 t0, ref ivec3 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static imat4x2 InnerProduct1(imat4x3 t0, imat3x2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static imat4x2 InnerProduct1(ref imat4x3 t0, ref imat3x2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static imat4x3 InnerProduct1(imat4x3 t0, imat3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static imat4x3 InnerProduct1(ref imat4x3 t0, ref imat3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static imat4 InnerProduct1(imat4x3 t0, imat3x4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static imat4 InnerProduct1(ref imat4x3 t0, ref imat3x4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static int InnerProduct2(imat4x3 t0, imat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static int InnerProduct2(ref imat4x3 t0, ref imat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static imat3x4 Transpose(imat4x3 t0) {
            return new imat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static imat3x4 Transpose(ref imat4x3 t0) {
            return new imat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static imat3x2 Minor(imat4x3 t0, int i0, int i1) {
            return new imat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static imat3x2 Minor(ref imat4x3 t0, int i0, int i1) {
            return new imat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static int MagnitudeSquared(imat4x3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat4x3 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat4x3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat4x3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static ivec4 InnerProduct1(imat4 t0, ivec4 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static ivec4 InnerProduct1(ref imat4 t0, ref ivec4 t1) {
            return new ivec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static imat4x2 InnerProduct1(imat4 t0, imat4x2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static imat4x2 InnerProduct1(ref imat4 t0, ref imat4x2 t1) {
            return new imat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static imat4x3 InnerProduct1(imat4 t0, imat4x3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static imat4x3 InnerProduct1(ref imat4 t0, ref imat4x3 t1) {
            return new imat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static imat4 InnerProduct1(imat4 t0, imat4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static imat4 InnerProduct1(ref imat4 t0, ref imat4 t1) {
            return new imat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static int InnerProduct2(imat4 t0, imat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static int InnerProduct2(ref imat4 t0, ref imat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static imat4 Transpose(imat4 t0) {
            return new imat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static imat4 Transpose(ref imat4 t0) {
            return new imat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static imat3 Minor(imat4 t0, int i0, int i1) {
            return new imat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static imat3 Minor(ref imat4 t0, int i0, int i1) {
            return new imat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static int MagnitudeSquared(imat4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref imat4 t0) {
            return imath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(imat4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref imat4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
    }
}
