#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class imath {
        
        public static int InnerProduct1(ivec2 t0, ivec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static int InnerProduct1(ref ivec2 t0, ref ivec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static ivec2 InnerProduct1(ivec2 t0, imat2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static ivec2 InnerProduct1(ref ivec2 t0, ref imat2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static ivec3 InnerProduct1(ivec2 t0, imat2x3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static ivec3 InnerProduct1(ref ivec2 t0, ref imat2x3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static ivec4 InnerProduct1(ivec2 t0, imat2x4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static ivec4 InnerProduct1(ref ivec2 t0, ref imat2x4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static imat2 OuterProduct(ivec2 t0, ivec2 t1) {
            return new imat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static imat2 OuterProduct(ref ivec2 t0, ref ivec2 t1) {
            return new imat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static imat3x2 OuterProduct(ivec2 t0, ivec3 t1) {
            return new imat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static imat3x2 OuterProduct(ref ivec2 t0, ref ivec3 t1) {
            return new imat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static imat4x2 OuterProduct(ivec2 t0, ivec4 t1) {
            return new imat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static imat4x2 OuterProduct(ref ivec2 t0, ref ivec4 t1) {
            return new imat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static ivec2 Transpose(ivec2 t0) {
            return new ivec2(t0.v0, t0.v1);
        }
        
        public static ivec2 Transpose(ref ivec2 t0) {
            return new ivec2(t0.v0, t0.v1);
        }
        
        public static int Minor(ivec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static int Minor(ref ivec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static int MagnitudeSquared(ivec2 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref ivec2 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(ivec2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref ivec2 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static int InnerProduct1(ivec3 t0, ivec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static int InnerProduct1(ref ivec3 t0, ref ivec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static ivec2 InnerProduct1(ivec3 t0, imat3x2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static ivec2 InnerProduct1(ref ivec3 t0, ref imat3x2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static ivec3 InnerProduct1(ivec3 t0, imat3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static ivec3 InnerProduct1(ref ivec3 t0, ref imat3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static ivec4 InnerProduct1(ivec3 t0, imat3x4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static ivec4 InnerProduct1(ref ivec3 t0, ref imat3x4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static imat2x3 OuterProduct(ivec3 t0, ivec2 t1) {
            return new imat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static imat2x3 OuterProduct(ref ivec3 t0, ref ivec2 t1) {
            return new imat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static imat3 OuterProduct(ivec3 t0, ivec3 t1) {
            return new imat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static imat3 OuterProduct(ref ivec3 t0, ref ivec3 t1) {
            return new imat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static imat4x3 OuterProduct(ivec3 t0, ivec4 t1) {
            return new imat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static imat4x3 OuterProduct(ref ivec3 t0, ref ivec4 t1) {
            return new imat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static ivec3 Transpose(ivec3 t0) {
            return new ivec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static ivec3 Transpose(ref ivec3 t0) {
            return new ivec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static ivec2 Minor(ivec3 t0, int i0) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static ivec2 Minor(ref ivec3 t0, int i0) {
            return new ivec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static int MagnitudeSquared(ivec3 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref ivec3 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(ivec3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref ivec3 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static int InnerProduct1(ivec4 t0, ivec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static int InnerProduct1(ref ivec4 t0, ref ivec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static ivec2 InnerProduct1(ivec4 t0, imat4x2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static ivec2 InnerProduct1(ref ivec4 t0, ref imat4x2 t1) {
            return new ivec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static ivec3 InnerProduct1(ivec4 t0, imat4x3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static ivec3 InnerProduct1(ref ivec4 t0, ref imat4x3 t1) {
            return new ivec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static ivec4 InnerProduct1(ivec4 t0, imat4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static ivec4 InnerProduct1(ref ivec4 t0, ref imat4 t1) {
            return new ivec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static imat2x4 OuterProduct(ivec4 t0, ivec2 t1) {
            return new imat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static imat2x4 OuterProduct(ref ivec4 t0, ref ivec2 t1) {
            return new imat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static imat3x4 OuterProduct(ivec4 t0, ivec3 t1) {
            return new imat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static imat3x4 OuterProduct(ref ivec4 t0, ref ivec3 t1) {
            return new imat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static imat4 OuterProduct(ivec4 t0, ivec4 t1) {
            return new imat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static imat4 OuterProduct(ref ivec4 t0, ref ivec4 t1) {
            return new imat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static ivec4 Transpose(ivec4 t0) {
            return new ivec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static ivec4 Transpose(ref ivec4 t0) {
            return new ivec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static ivec3 Minor(ivec4 t0, int i0) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static ivec3 Minor(ref ivec4 t0, int i0) {
            return new ivec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static int MagnitudeSquared(ivec4 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static int MagnitudeSquared(ref ivec4 t0) {
            return imath.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(ivec4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref ivec4 t) {
            return System.Math.Sqrt(imath.MagnitudeSquared(ref t));
        }
    }
}
