#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static vec2 InnerProduct1(mat2 t0, vec2 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static vec2 InnerProduct1(ref mat2 t0, ref vec2 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static mat2 InnerProduct1(mat2 t0, mat2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static mat2 InnerProduct1(ref mat2 t0, ref mat2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static mat2x3 InnerProduct1(mat2 t0, mat2x3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static mat2x3 InnerProduct1(ref mat2 t0, ref mat2x3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static mat2x4 InnerProduct1(mat2 t0, mat2x4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static mat2x4 InnerProduct1(ref mat2 t0, ref mat2x4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static float InnerProduct2(mat2 t0, mat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static float InnerProduct2(ref mat2 t0, ref mat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static mat2 Transpose(mat2 t0) {
            return new mat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static mat2 Transpose(ref mat2 t0) {
            return new mat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static float Minor(mat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static float Minor(ref mat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static float MagnitudeSquared(mat2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec2 InnerProduct1(mat2x3 t0, vec3 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static vec2 InnerProduct1(ref mat2x3 t0, ref vec3 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static mat2 InnerProduct1(mat2x3 t0, mat3x2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static mat2 InnerProduct1(ref mat2x3 t0, ref mat3x2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static mat2x3 InnerProduct1(mat2x3 t0, mat3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static mat2x3 InnerProduct1(ref mat2x3 t0, ref mat3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static mat2x4 InnerProduct1(mat2x3 t0, mat3x4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static mat2x4 InnerProduct1(ref mat2x3 t0, ref mat3x4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static float InnerProduct2(mat2x3 t0, mat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static float InnerProduct2(ref mat2x3 t0, ref mat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static mat3x2 Transpose(mat2x3 t0) {
            return new mat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static mat3x2 Transpose(ref mat2x3 t0) {
            return new mat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static vec2 Minor(mat2x3 t0, int i0, int i1) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static vec2 Minor(ref mat2x3 t0, int i0, int i1) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static float MagnitudeSquared(mat2x3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat2x3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat2x3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat2x3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec2 InnerProduct1(mat2x4 t0, vec4 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static vec2 InnerProduct1(ref mat2x4 t0, ref vec4 t1) {
            return new vec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static mat2 InnerProduct1(mat2x4 t0, mat4x2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static mat2 InnerProduct1(ref mat2x4 t0, ref mat4x2 t1) {
            return new mat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static mat2x3 InnerProduct1(mat2x4 t0, mat4x3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static mat2x3 InnerProduct1(ref mat2x4 t0, ref mat4x3 t1) {
            return new mat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static mat2x4 InnerProduct1(mat2x4 t0, mat4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static mat2x4 InnerProduct1(ref mat2x4 t0, ref mat4 t1) {
            return new mat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static float InnerProduct2(mat2x4 t0, mat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static float InnerProduct2(ref mat2x4 t0, ref mat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static mat4x2 Transpose(mat2x4 t0) {
            return new mat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static mat4x2 Transpose(ref mat2x4 t0) {
            return new mat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static vec3 Minor(mat2x4 t0, int i0, int i1) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static vec3 Minor(ref mat2x4 t0, int i0, int i1) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static float MagnitudeSquared(mat2x4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat2x4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat2x4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat2x4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec3 InnerProduct1(mat3x2 t0, vec2 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static vec3 InnerProduct1(ref mat3x2 t0, ref vec2 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static mat3x2 InnerProduct1(mat3x2 t0, mat2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static mat3x2 InnerProduct1(ref mat3x2 t0, ref mat2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static mat3 InnerProduct1(mat3x2 t0, mat2x3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static mat3 InnerProduct1(ref mat3x2 t0, ref mat2x3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static mat3x4 InnerProduct1(mat3x2 t0, mat2x4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static mat3x4 InnerProduct1(ref mat3x2 t0, ref mat2x4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static float InnerProduct2(mat3x2 t0, mat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static float InnerProduct2(ref mat3x2 t0, ref mat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static mat2x3 Transpose(mat3x2 t0) {
            return new mat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static mat2x3 Transpose(ref mat3x2 t0) {
            return new mat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static vec2 Minor(mat3x2 t0, int i0, int i1) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static vec2 Minor(ref mat3x2 t0, int i0, int i1) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static float MagnitudeSquared(mat3x2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat3x2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat3x2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat3x2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec3 InnerProduct1(mat3 t0, vec3 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static vec3 InnerProduct1(ref mat3 t0, ref vec3 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static mat3x2 InnerProduct1(mat3 t0, mat3x2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static mat3x2 InnerProduct1(ref mat3 t0, ref mat3x2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static mat3 InnerProduct1(mat3 t0, mat3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static mat3 InnerProduct1(ref mat3 t0, ref mat3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static mat3x4 InnerProduct1(mat3 t0, mat3x4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static mat3x4 InnerProduct1(ref mat3 t0, ref mat3x4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static float InnerProduct2(mat3 t0, mat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static float InnerProduct2(ref mat3 t0, ref mat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static mat3 Transpose(mat3 t0) {
            return new mat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static mat3 Transpose(ref mat3 t0) {
            return new mat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static mat2 Minor(mat3 t0, int i0, int i1) {
            return new mat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static mat2 Minor(ref mat3 t0, int i0, int i1) {
            return new mat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static float MagnitudeSquared(mat3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec3 InnerProduct1(mat3x4 t0, vec4 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static vec3 InnerProduct1(ref mat3x4 t0, ref vec4 t1) {
            return new vec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static mat3x2 InnerProduct1(mat3x4 t0, mat4x2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static mat3x2 InnerProduct1(ref mat3x4 t0, ref mat4x2 t1) {
            return new mat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static mat3 InnerProduct1(mat3x4 t0, mat4x3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static mat3 InnerProduct1(ref mat3x4 t0, ref mat4x3 t1) {
            return new mat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static mat3x4 InnerProduct1(mat3x4 t0, mat4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static mat3x4 InnerProduct1(ref mat3x4 t0, ref mat4 t1) {
            return new mat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static float InnerProduct2(mat3x4 t0, mat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static float InnerProduct2(ref mat3x4 t0, ref mat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static mat4x3 Transpose(mat3x4 t0) {
            return new mat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static mat4x3 Transpose(ref mat3x4 t0) {
            return new mat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static mat2x3 Minor(mat3x4 t0, int i0, int i1) {
            return new mat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static mat2x3 Minor(ref mat3x4 t0, int i0, int i1) {
            return new mat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static float MagnitudeSquared(mat3x4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat3x4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat3x4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat3x4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec4 InnerProduct1(mat4x2 t0, vec2 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static vec4 InnerProduct1(ref mat4x2 t0, ref vec2 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static mat4x2 InnerProduct1(mat4x2 t0, mat2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static mat4x2 InnerProduct1(ref mat4x2 t0, ref mat2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static mat4x3 InnerProduct1(mat4x2 t0, mat2x3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static mat4x3 InnerProduct1(ref mat4x2 t0, ref mat2x3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static mat4 InnerProduct1(mat4x2 t0, mat2x4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static mat4 InnerProduct1(ref mat4x2 t0, ref mat2x4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static float InnerProduct2(mat4x2 t0, mat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static float InnerProduct2(ref mat4x2 t0, ref mat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static mat2x4 Transpose(mat4x2 t0) {
            return new mat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static mat2x4 Transpose(ref mat4x2 t0) {
            return new mat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static vec3 Minor(mat4x2 t0, int i0, int i1) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static vec3 Minor(ref mat4x2 t0, int i0, int i1) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static float MagnitudeSquared(mat4x2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat4x2 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat4x2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat4x2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec4 InnerProduct1(mat4x3 t0, vec3 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static vec4 InnerProduct1(ref mat4x3 t0, ref vec3 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static mat4x2 InnerProduct1(mat4x3 t0, mat3x2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static mat4x2 InnerProduct1(ref mat4x3 t0, ref mat3x2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static mat4x3 InnerProduct1(mat4x3 t0, mat3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static mat4x3 InnerProduct1(ref mat4x3 t0, ref mat3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static mat4 InnerProduct1(mat4x3 t0, mat3x4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static mat4 InnerProduct1(ref mat4x3 t0, ref mat3x4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static float InnerProduct2(mat4x3 t0, mat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static float InnerProduct2(ref mat4x3 t0, ref mat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static mat3x4 Transpose(mat4x3 t0) {
            return new mat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static mat3x4 Transpose(ref mat4x3 t0) {
            return new mat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static mat3x2 Minor(mat4x3 t0, int i0, int i1) {
            return new mat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static mat3x2 Minor(ref mat4x3 t0, int i0, int i1) {
            return new mat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static float MagnitudeSquared(mat4x3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat4x3 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat4x3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat4x3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static vec4 InnerProduct1(mat4 t0, vec4 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static vec4 InnerProduct1(ref mat4 t0, ref vec4 t1) {
            return new vec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static mat4x2 InnerProduct1(mat4 t0, mat4x2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static mat4x2 InnerProduct1(ref mat4 t0, ref mat4x2 t1) {
            return new mat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static mat4x3 InnerProduct1(mat4 t0, mat4x3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static mat4x3 InnerProduct1(ref mat4 t0, ref mat4x3 t1) {
            return new mat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static mat4 InnerProduct1(mat4 t0, mat4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static mat4 InnerProduct1(ref mat4 t0, ref mat4 t1) {
            return new mat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static float InnerProduct2(mat4 t0, mat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static float InnerProduct2(ref mat4 t0, ref mat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static mat4 Transpose(mat4 t0) {
            return new mat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static mat4 Transpose(ref mat4 t0) {
            return new mat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static mat3 Minor(mat4 t0, int i0, int i1) {
            return new mat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static mat3 Minor(ref mat4 t0, int i0, int i1) {
            return new mat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static float MagnitudeSquared(mat4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref mat4 t0) {
            return math.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(mat4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref mat4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
    }
}
