#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class umath {
        
        public static uvec2 InnerProduct1(umat2 t0, uvec2 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static uvec2 InnerProduct1(ref umat2 t0, ref uvec2 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1));
        }
        
        public static umat2 InnerProduct1(umat2 t0, umat2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static umat2 InnerProduct1(ref umat2 t0, ref umat2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11));
        }
        
        public static umat2x3 InnerProduct1(umat2 t0, umat2x3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static umat2x3 InnerProduct1(ref umat2 t0, ref umat2x3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12));
        }
        
        public static umat2x4 InnerProduct1(umat2 t0, umat2x4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static umat2x4 InnerProduct1(ref umat2 t0, ref umat2x4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13));
        }
        
        public static uint InnerProduct2(umat2 t0, umat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static uint InnerProduct2(ref umat2 t0, ref umat2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11);
        }
        
        public static umat2 Transpose(umat2 t0) {
            return new umat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static umat2 Transpose(ref umat2 t0) {
            return new umat2(t0.m00, t0.m10, t0.m01, t0.m11);
        }
        
        public static uint Minor(umat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static uint Minor(ref umat2 t0, int i0, int i1) {
            return t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0];
        }
        
        public static uint MagnitudeSquared(umat2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec2 InnerProduct1(umat2x3 t0, uvec3 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static uvec2 InnerProduct1(ref umat2x3 t0, ref uvec3 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2));
        }
        
        public static umat2 InnerProduct1(umat2x3 t0, umat3x2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static umat2 InnerProduct1(ref umat2x3 t0, ref umat3x2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21));
        }
        
        public static umat2x3 InnerProduct1(umat2x3 t0, umat3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static umat2x3 InnerProduct1(ref umat2x3 t0, ref umat3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22));
        }
        
        public static umat2x4 InnerProduct1(umat2x3 t0, umat3x4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static umat2x4 InnerProduct1(ref umat2x3 t0, ref umat3x4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23));
        }
        
        public static uint InnerProduct2(umat2x3 t0, umat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static uint InnerProduct2(ref umat2x3 t0, ref umat2x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12);
        }
        
        public static umat3x2 Transpose(umat2x3 t0) {
            return new umat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static umat3x2 Transpose(ref umat2x3 t0) {
            return new umat3x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12);
        }
        
        public static uvec2 Minor(umat2x3 t0, int i0, int i1) {
            return new uvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static uvec2 Minor(ref umat2x3 t0, int i0, int i1) {
            return new uvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static uint MagnitudeSquared(umat2x3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat2x3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat2x3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat2x3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec2 InnerProduct1(umat2x4 t0, uvec4 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static uvec2 InnerProduct1(ref umat2x4 t0, ref uvec4 t1) {
            return new uvec2((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3));
        }
        
        public static umat2 InnerProduct1(umat2x4 t0, umat4x2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static umat2 InnerProduct1(ref umat2x4 t0, ref umat4x2 t1) {
            return new umat2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31));
        }
        
        public static umat2x3 InnerProduct1(umat2x4 t0, umat4x3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static umat2x3 InnerProduct1(ref umat2x4 t0, ref umat4x3 t1) {
            return new umat2x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32));
        }
        
        public static umat2x4 InnerProduct1(umat2x4 t0, umat4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static umat2x4 InnerProduct1(ref umat2x4 t0, ref umat4 t1) {
            return new umat2x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33));
        }
        
        public static uint InnerProduct2(umat2x4 t0, umat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static uint InnerProduct2(ref umat2x4 t0, ref umat2x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13);
        }
        
        public static umat4x2 Transpose(umat2x4 t0) {
            return new umat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static umat4x2 Transpose(ref umat2x4 t0) {
            return new umat4x2(t0.m00, t0.m10, t0.m01, t0.m11, t0.m02, t0.m12, t0.m03, t0.m13);
        }
        
        public static uvec3 Minor(umat2x4 t0, int i0, int i1) {
            return new uvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static uvec3 Minor(ref umat2x4 t0, int i0, int i1) {
            return new uvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static uint MagnitudeSquared(umat2x4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat2x4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat2x4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat2x4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec3 InnerProduct1(umat3x2 t0, uvec2 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static uvec3 InnerProduct1(ref umat3x2 t0, ref uvec2 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1));
        }
        
        public static umat3x2 InnerProduct1(umat3x2 t0, umat2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static umat3x2 InnerProduct1(ref umat3x2 t0, ref umat2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11));
        }
        
        public static umat3 InnerProduct1(umat3x2 t0, umat2x3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static umat3 InnerProduct1(ref umat3x2 t0, ref umat2x3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12));
        }
        
        public static umat3x4 InnerProduct1(umat3x2 t0, umat2x4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static umat3x4 InnerProduct1(ref umat3x2 t0, ref umat2x4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13));
        }
        
        public static uint InnerProduct2(umat3x2 t0, umat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static uint InnerProduct2(ref umat3x2 t0, ref umat3x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21);
        }
        
        public static umat2x3 Transpose(umat3x2 t0) {
            return new umat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static umat2x3 Transpose(ref umat3x2 t0) {
            return new umat2x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21);
        }
        
        public static uvec2 Minor(umat3x2 t0, int i0, int i1) {
            return new uvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static uvec2 Minor(ref umat3x2 t0, int i0, int i1) {
            return new uvec2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static uint MagnitudeSquared(umat3x2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat3x2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat3x2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat3x2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec3 InnerProduct1(umat3 t0, uvec3 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static uvec3 InnerProduct1(ref umat3 t0, ref uvec3 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2));
        }
        
        public static umat3x2 InnerProduct1(umat3 t0, umat3x2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static umat3x2 InnerProduct1(ref umat3 t0, ref umat3x2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21));
        }
        
        public static umat3 InnerProduct1(umat3 t0, umat3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static umat3 InnerProduct1(ref umat3 t0, ref umat3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22));
        }
        
        public static umat3x4 InnerProduct1(umat3 t0, umat3x4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static umat3x4 InnerProduct1(ref umat3 t0, ref umat3x4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23));
        }
        
        public static uint InnerProduct2(umat3 t0, umat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static uint InnerProduct2(ref umat3 t0, ref umat3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22);
        }
        
        public static umat3 Transpose(umat3 t0) {
            return new umat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static umat3 Transpose(ref umat3 t0) {
            return new umat3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22);
        }
        
        public static umat2 Minor(umat3 t0, int i0, int i1) {
            return new umat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static umat2 Minor(ref umat3 t0, int i0, int i1) {
            return new umat2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static uint MagnitudeSquared(umat3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec3 InnerProduct1(umat3x4 t0, uvec4 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static uvec3 InnerProduct1(ref umat3x4 t0, ref uvec4 t1) {
            return new uvec3((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3));
        }
        
        public static umat3x2 InnerProduct1(umat3x4 t0, umat4x2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static umat3x2 InnerProduct1(ref umat3x4 t0, ref umat4x2 t1) {
            return new umat3x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31));
        }
        
        public static umat3 InnerProduct1(umat3x4 t0, umat4x3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static umat3 InnerProduct1(ref umat3x4 t0, ref umat4x3 t1) {
            return new umat3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32));
        }
        
        public static umat3x4 InnerProduct1(umat3x4 t0, umat4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static umat3x4 InnerProduct1(ref umat3x4 t0, ref umat4 t1) {
            return new umat3x4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33));
        }
        
        public static uint InnerProduct2(umat3x4 t0, umat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static uint InnerProduct2(ref umat3x4 t0, ref umat3x4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23);
        }
        
        public static umat4x3 Transpose(umat3x4 t0) {
            return new umat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static umat4x3 Transpose(ref umat3x4 t0) {
            return new umat4x3(t0.m00, t0.m10, t0.m20, t0.m01, t0.m11, t0.m21, t0.m02, t0.m12, t0.m22, t0.m03, t0.m13, t0.m23);
        }
        
        public static umat2x3 Minor(umat3x4 t0, int i0, int i1) {
            return new umat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static umat2x3 Minor(ref umat3x4 t0, int i0, int i1) {
            return new umat2x3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static uint MagnitudeSquared(umat3x4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat3x4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat3x4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat3x4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec4 InnerProduct1(umat4x2 t0, uvec2 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static uvec4 InnerProduct1(ref umat4x2 t0, ref uvec2 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1), (t0.m10 * t1.v0) + (t0.m11 * t1.v1), (t0.m20 * t1.v0) + (t0.m21 * t1.v1), (t0.m30 * t1.v0) + (t0.m31 * t1.v1));
        }
        
        public static umat4x2 InnerProduct1(umat4x2 t0, umat2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static umat4x2 InnerProduct1(ref umat4x2 t0, ref umat2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11));
        }
        
        public static umat4x3 InnerProduct1(umat4x2 t0, umat2x3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static umat4x3 InnerProduct1(ref umat4x2 t0, ref umat2x3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12));
        }
        
        public static umat4 InnerProduct1(umat4x2 t0, umat2x4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static umat4 InnerProduct1(ref umat4x2 t0, ref umat2x4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10), (t0.m00 * t1.m01) + (t0.m01 * t1.m11), (t0.m00 * t1.m02) + (t0.m01 * t1.m12), (t0.m00 * t1.m03) + (t0.m01 * t1.m13), (t0.m10 * t1.m00) + (t0.m11 * t1.m10), (t0.m10 * t1.m01) + (t0.m11 * t1.m11), (t0.m10 * t1.m02) + (t0.m11 * t1.m12), (t0.m10 * t1.m03) + (t0.m11 * t1.m13), (t0.m20 * t1.m00) + (t0.m21 * t1.m10), (t0.m20 * t1.m01) + (t0.m21 * t1.m11), (t0.m20 * t1.m02) + (t0.m21 * t1.m12), (t0.m20 * t1.m03) + (t0.m21 * t1.m13), (t0.m30 * t1.m00) + (t0.m31 * t1.m10), (t0.m30 * t1.m01) + (t0.m31 * t1.m11), (t0.m30 * t1.m02) + (t0.m31 * t1.m12), (t0.m30 * t1.m03) + (t0.m31 * t1.m13));
        }
        
        public static uint InnerProduct2(umat4x2 t0, umat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static uint InnerProduct2(ref umat4x2 t0, ref umat4x2 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31);
        }
        
        public static umat2x4 Transpose(umat4x2 t0) {
            return new umat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static umat2x4 Transpose(ref umat4x2 t0) {
            return new umat2x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31);
        }
        
        public static uvec3 Minor(umat4x2 t0, int i0, int i1) {
            return new uvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static uvec3 Minor(ref umat4x2 t0, int i0, int i1) {
            return new uvec3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0]);
        }
        
        public static uint MagnitudeSquared(umat4x2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat4x2 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat4x2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat4x2 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec4 InnerProduct1(umat4x3 t0, uvec3 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static uvec4 InnerProduct1(ref umat4x3 t0, ref uvec3 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2));
        }
        
        public static umat4x2 InnerProduct1(umat4x3 t0, umat3x2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static umat4x2 InnerProduct1(ref umat4x3 t0, ref umat3x2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21));
        }
        
        public static umat4x3 InnerProduct1(umat4x3 t0, umat3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static umat4x3 InnerProduct1(ref umat4x3 t0, ref umat3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22));
        }
        
        public static umat4 InnerProduct1(umat4x3 t0, umat3x4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static umat4 InnerProduct1(ref umat4x3 t0, ref umat3x4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23));
        }
        
        public static uint InnerProduct2(umat4x3 t0, umat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static uint InnerProduct2(ref umat4x3 t0, ref umat4x3 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32);
        }
        
        public static umat3x4 Transpose(umat4x3 t0) {
            return new umat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static umat3x4 Transpose(ref umat4x3 t0) {
            return new umat3x4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32);
        }
        
        public static umat3x2 Minor(umat4x3 t0, int i0, int i1) {
            return new umat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static umat3x2 Minor(ref umat4x3 t0, int i0, int i1) {
            return new umat3x2(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1]);
        }
        
        public static uint MagnitudeSquared(umat4x3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat4x3 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat4x3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat4x3 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static uvec4 InnerProduct1(umat4 t0, uvec4 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static uvec4 InnerProduct1(ref umat4 t0, ref uvec4 t1) {
            return new uvec4((t0.m00 * t1.v0) + (t0.m01 * t1.v1) + (t0.m02 * t1.v2) + (t0.m03 * t1.v3), (t0.m10 * t1.v0) + (t0.m11 * t1.v1) + (t0.m12 * t1.v2) + (t0.m13 * t1.v3), (t0.m20 * t1.v0) + (t0.m21 * t1.v1) + (t0.m22 * t1.v2) + (t0.m23 * t1.v3), (t0.m30 * t1.v0) + (t0.m31 * t1.v1) + (t0.m32 * t1.v2) + (t0.m33 * t1.v3));
        }
        
        public static umat4x2 InnerProduct1(umat4 t0, umat4x2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static umat4x2 InnerProduct1(ref umat4 t0, ref umat4x2 t1) {
            return new umat4x2((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31));
        }
        
        public static umat4x3 InnerProduct1(umat4 t0, umat4x3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static umat4x3 InnerProduct1(ref umat4 t0, ref umat4x3 t1) {
            return new umat4x3((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32));
        }
        
        public static umat4 InnerProduct1(umat4 t0, umat4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static umat4 InnerProduct1(ref umat4 t0, ref umat4 t1) {
            return new umat4((t0.m00 * t1.m00) + (t0.m01 * t1.m10) + (t0.m02 * t1.m20) + (t0.m03 * t1.m30), (t0.m00 * t1.m01) + (t0.m01 * t1.m11) + (t0.m02 * t1.m21) + (t0.m03 * t1.m31), (t0.m00 * t1.m02) + (t0.m01 * t1.m12) + (t0.m02 * t1.m22) + (t0.m03 * t1.m32), (t0.m00 * t1.m03) + (t0.m01 * t1.m13) + (t0.m02 * t1.m23) + (t0.m03 * t1.m33), (t0.m10 * t1.m00) + (t0.m11 * t1.m10) + (t0.m12 * t1.m20) + (t0.m13 * t1.m30), (t0.m10 * t1.m01) + (t0.m11 * t1.m11) + (t0.m12 * t1.m21) + (t0.m13 * t1.m31), (t0.m10 * t1.m02) + (t0.m11 * t1.m12) + (t0.m12 * t1.m22) + (t0.m13 * t1.m32), (t0.m10 * t1.m03) + (t0.m11 * t1.m13) + (t0.m12 * t1.m23) + (t0.m13 * t1.m33), (t0.m20 * t1.m00) + (t0.m21 * t1.m10) + (t0.m22 * t1.m20) + (t0.m23 * t1.m30), (t0.m20 * t1.m01) + (t0.m21 * t1.m11) + (t0.m22 * t1.m21) + (t0.m23 * t1.m31), (t0.m20 * t1.m02) + (t0.m21 * t1.m12) + (t0.m22 * t1.m22) + (t0.m23 * t1.m32), (t0.m20 * t1.m03) + (t0.m21 * t1.m13) + (t0.m22 * t1.m23) + (t0.m23 * t1.m33), (t0.m30 * t1.m00) + (t0.m31 * t1.m10) + (t0.m32 * t1.m20) + (t0.m33 * t1.m30), (t0.m30 * t1.m01) + (t0.m31 * t1.m11) + (t0.m32 * t1.m21) + (t0.m33 * t1.m31), (t0.m30 * t1.m02) + (t0.m31 * t1.m12) + (t0.m32 * t1.m22) + (t0.m33 * t1.m32), (t0.m30 * t1.m03) + (t0.m31 * t1.m13) + (t0.m32 * t1.m23) + (t0.m33 * t1.m33));
        }
        
        public static uint InnerProduct2(umat4 t0, umat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static uint InnerProduct2(ref umat4 t0, ref umat4 t1) {
            return (t0.m00 * t1.m00) + (t0.m01 * t1.m01) + (t0.m02 * t1.m02) + (t0.m03 * t1.m03) + (t0.m10 * t1.m10) + (t0.m11 * t1.m11) + (t0.m12 * t1.m12) + (t0.m13 * t1.m13) + (t0.m20 * t1.m20) + (t0.m21 * t1.m21) + (t0.m22 * t1.m22) + (t0.m23 * t1.m23) + (t0.m30 * t1.m30) + (t0.m31 * t1.m31) + (t0.m32 * t1.m32) + (t0.m33 * t1.m33);
        }
        
        public static umat4 Transpose(umat4 t0) {
            return new umat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static umat4 Transpose(ref umat4 t0) {
            return new umat4(t0.m00, t0.m10, t0.m20, t0.m30, t0.m01, t0.m11, t0.m21, t0.m31, t0.m02, t0.m12, t0.m22, t0.m32, t0.m03, t0.m13, t0.m23, t0.m33);
        }
        
        public static umat3 Minor(umat4 t0, int i0, int i1) {
            return new umat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static umat3 Minor(ref umat4 t0, int i0, int i1) {
            return new umat3(t0[(0 < i0 ? 0 : 1) + 0, (0 < i1 ? 0 : 1) + 0], t0[(0 < i0 ? 0 : 1) + 0, (1 < i1 ? 0 : 1) + 1], t0[(0 < i0 ? 0 : 1) + 0, (2 < i1 ? 0 : 1) + 2], t0[(1 < i0 ? 0 : 1) + 1, (0 < i1 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1, (1 < i1 ? 0 : 1) + 1], t0[(1 < i0 ? 0 : 1) + 1, (2 < i1 ? 0 : 1) + 2], t0[(2 < i0 ? 0 : 1) + 2, (0 < i1 ? 0 : 1) + 0], t0[(2 < i0 ? 0 : 1) + 2, (1 < i1 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2, (2 < i1 ? 0 : 1) + 2]);
        }
        
        public static uint MagnitudeSquared(umat4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static uint MagnitudeSquared(ref umat4 t0) {
            return umath.InnerProduct2(ref t0, ref t0);
        }
        
        public static double Magnitude(umat4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref umat4 t) {
            return System.Math.Sqrt(umath.MagnitudeSquared(ref t));
        }
    }
}
