#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class math {
        
        public static float InnerProduct1(vec2 t0, vec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static float InnerProduct1(ref vec2 t0, ref vec2 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1);
        }
        
        public static vec2 InnerProduct1(vec2 t0, mat2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static vec2 InnerProduct1(ref vec2 t0, ref mat2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11));
        }
        
        public static vec3 InnerProduct1(vec2 t0, mat2x3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static vec3 InnerProduct1(ref vec2 t0, ref mat2x3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12));
        }
        
        public static vec4 InnerProduct1(vec2 t0, mat2x4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static vec4 InnerProduct1(ref vec2 t0, ref mat2x4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10), (t0.v0 * t1.m01) + (t0.v1 * t1.m11), (t0.v0 * t1.m02) + (t0.v1 * t1.m12), (t0.v0 * t1.m03) + (t0.v1 * t1.m13));
        }
        
        public static mat2 OuterProduct(vec2 t0, vec2 t1) {
            return new mat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static mat2 OuterProduct(ref vec2 t0, ref vec2 t1) {
            return new mat2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1));
        }
        
        public static mat3x2 OuterProduct(vec2 t0, vec3 t1) {
            return new mat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static mat3x2 OuterProduct(ref vec2 t0, ref vec3 t1) {
            return new mat3x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2));
        }
        
        public static mat4x2 OuterProduct(vec2 t0, vec4 t1) {
            return new mat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static mat4x2 OuterProduct(ref vec2 t0, ref vec4 t1) {
            return new mat4x2((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3));
        }
        
        public static vec2 Transpose(vec2 t0) {
            return new vec2(t0.v0, t0.v1);
        }
        
        public static vec2 Transpose(ref vec2 t0) {
            return new vec2(t0.v0, t0.v1);
        }
        
        public static float Minor(vec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static float Minor(ref vec2 t0, int i0) {
            return t0[(0 < i0 ? 0 : 1) + 0];
        }
        
        public static float MagnitudeSquared(vec2 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref vec2 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(vec2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref vec2 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static float InnerProduct1(vec3 t0, vec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static float InnerProduct1(ref vec3 t0, ref vec3 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2);
        }
        
        public static vec2 InnerProduct1(vec3 t0, mat3x2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static vec2 InnerProduct1(ref vec3 t0, ref mat3x2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21));
        }
        
        public static vec3 InnerProduct1(vec3 t0, mat3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static vec3 InnerProduct1(ref vec3 t0, ref mat3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22));
        }
        
        public static vec4 InnerProduct1(vec3 t0, mat3x4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static vec4 InnerProduct1(ref vec3 t0, ref mat3x4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23));
        }
        
        public static mat2x3 OuterProduct(vec3 t0, vec2 t1) {
            return new mat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static mat2x3 OuterProduct(ref vec3 t0, ref vec2 t1) {
            return new mat2x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1));
        }
        
        public static mat3 OuterProduct(vec3 t0, vec3 t1) {
            return new mat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static mat3 OuterProduct(ref vec3 t0, ref vec3 t1) {
            return new mat3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2));
        }
        
        public static mat4x3 OuterProduct(vec3 t0, vec4 t1) {
            return new mat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static mat4x3 OuterProduct(ref vec3 t0, ref vec4 t1) {
            return new mat4x3((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3));
        }
        
        public static vec3 Transpose(vec3 t0) {
            return new vec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static vec3 Transpose(ref vec3 t0) {
            return new vec3(t0.v0, t0.v1, t0.v2);
        }
        
        public static vec2 Minor(vec3 t0, int i0) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static vec2 Minor(ref vec3 t0, int i0) {
            return new vec2(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1]);
        }
        
        public static float MagnitudeSquared(vec3 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref vec3 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(vec3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref vec3 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static float InnerProduct1(vec4 t0, vec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static float InnerProduct1(ref vec4 t0, ref vec4 t1) {
            return (t0.v0 * t1.v0) + (t0.v1 * t1.v1) + (t0.v2 * t1.v2) + (t0.v3 * t1.v3);
        }
        
        public static vec2 InnerProduct1(vec4 t0, mat4x2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static vec2 InnerProduct1(ref vec4 t0, ref mat4x2 t1) {
            return new vec2((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31));
        }
        
        public static vec3 InnerProduct1(vec4 t0, mat4x3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static vec3 InnerProduct1(ref vec4 t0, ref mat4x3 t1) {
            return new vec3((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32));
        }
        
        public static vec4 InnerProduct1(vec4 t0, mat4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static vec4 InnerProduct1(ref vec4 t0, ref mat4 t1) {
            return new vec4((t0.v0 * t1.m00) + (t0.v1 * t1.m10) + (t0.v2 * t1.m20) + (t0.v3 * t1.m30), (t0.v0 * t1.m01) + (t0.v1 * t1.m11) + (t0.v2 * t1.m21) + (t0.v3 * t1.m31), (t0.v0 * t1.m02) + (t0.v1 * t1.m12) + (t0.v2 * t1.m22) + (t0.v3 * t1.m32), (t0.v0 * t1.m03) + (t0.v1 * t1.m13) + (t0.v2 * t1.m23) + (t0.v3 * t1.m33));
        }
        
        public static mat2x4 OuterProduct(vec4 t0, vec2 t1) {
            return new mat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static mat2x4 OuterProduct(ref vec4 t0, ref vec2 t1) {
            return new mat2x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1));
        }
        
        public static mat3x4 OuterProduct(vec4 t0, vec3 t1) {
            return new mat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static mat3x4 OuterProduct(ref vec4 t0, ref vec3 t1) {
            return new mat3x4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2));
        }
        
        public static mat4 OuterProduct(vec4 t0, vec4 t1) {
            return new mat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static mat4 OuterProduct(ref vec4 t0, ref vec4 t1) {
            return new mat4((t0.v0 * t1.v0), (t0.v1 * t1.v0), (t0.v2 * t1.v0), (t0.v3 * t1.v0), (t0.v0 * t1.v1), (t0.v1 * t1.v1), (t0.v2 * t1.v1), (t0.v3 * t1.v1), (t0.v0 * t1.v2), (t0.v1 * t1.v2), (t0.v2 * t1.v2), (t0.v3 * t1.v2), (t0.v0 * t1.v3), (t0.v1 * t1.v3), (t0.v2 * t1.v3), (t0.v3 * t1.v3));
        }
        
        public static vec4 Transpose(vec4 t0) {
            return new vec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static vec4 Transpose(ref vec4 t0) {
            return new vec4(t0.v0, t0.v1, t0.v2, t0.v3);
        }
        
        public static vec3 Minor(vec4 t0, int i0) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static vec3 Minor(ref vec4 t0, int i0) {
            return new vec3(t0[(0 < i0 ? 0 : 1) + 0], t0[(1 < i0 ? 0 : 1) + 1], t0[(2 < i0 ? 0 : 1) + 2]);
        }
        
        public static float MagnitudeSquared(vec4 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static float MagnitudeSquared(ref vec4 t0) {
            return math.InnerProduct1(ref t0, ref t0);
        }
        
        public static double Magnitude(vec4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
        
        public static double Magnitude(ref vec4 t) {
            return System.Math.Sqrt(math.MagnitudeSquared(ref t));
        }
    }
}
