#region --- License ---
/*
Copyright 2010 Daniel Filonik

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
#endregion

namespace TKM {
    using System;
    
    
    public partial class imath {
        
        public static void UnaryPlus(ref imat2 t, out imat2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
        }
        
        public static void Negate(ref imat2 t, out imat2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
        }
        
        public static void OnesComplement(ref imat2 t, out imat2 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
        }
        
        public static void Increment(ref imat2 t, out imat2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
        }
        
        public static void Decrement(ref imat2 t, out imat2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
        }
        
        public static void Add(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
        }
        
        public static void Subtract(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
        }
        
        public static void Multiply(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
        }
        
        public static void Divide(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
        }
        
        public static void Modulo(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
        }
        
        public static void And(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
        }
        
        public static void Or(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
        }
        
        public static void ExclusiveOr(int s1, ref imat2 t2, out imat2 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
        }
        
        public static void Add(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
        }
        
        public static void Subtract(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
        }
        
        public static void Multiply(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
        }
        
        public static void Divide(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
        }
        
        public static void Modulo(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
        }
        
        public static void And(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
        }
        
        public static void Or(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
        }
        
        public static void ExclusiveOr(ref imat2 t1, int s2, out imat2 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
        }
        
        public static void Add(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
        }
        
        public static void Subtract(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
        }
        
        public static void Multiply(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
        }
        
        public static void Divide(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
        }
        
        public static void Modulo(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
        }
        
        public static void And(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
        }
        
        public static void Or(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
        }
        
        public static void ExclusiveOr(ref imat2 t1, ref imat2 t2, out imat2 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
        }
        
        public static void Equal(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
        }
        
        public static void GreaterThan(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
        }
        
        public static void GreaterThanEqual(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
        }
        
        public static void LessThan(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
        }
        
        public static void LessThanEqual(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
        }
        
        public static void NotEqual(ref imat2 t1, ref imat2 t2, out bmat2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
        }
        
        public static void UnaryPlus(ref imat2x3 t, out imat2x3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
        }
        
        public static void Negate(ref imat2x3 t, out imat2x3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
        }
        
        public static void OnesComplement(ref imat2x3 t, out imat2x3 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
        }
        
        public static void Increment(ref imat2x3 t, out imat2x3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
        }
        
        public static void Decrement(ref imat2x3 t, out imat2x3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
        }
        
        public static void Add(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
        }
        
        public static void Subtract(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
        }
        
        public static void Multiply(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
        }
        
        public static void Divide(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
        }
        
        public static void Modulo(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
        }
        
        public static void And(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
        }
        
        public static void Or(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
        }
        
        public static void ExclusiveOr(int s1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
        }
        
        public static void Add(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
        }
        
        public static void Subtract(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
        }
        
        public static void Multiply(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
        }
        
        public static void Divide(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
        }
        
        public static void Modulo(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
        }
        
        public static void And(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
        }
        
        public static void Or(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
        }
        
        public static void ExclusiveOr(ref imat2x3 t1, int s2, out imat2x3 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
        }
        
        public static void Add(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
        }
        
        public static void Subtract(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
        }
        
        public static void Multiply(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
        }
        
        public static void Divide(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
        }
        
        public static void Modulo(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
        }
        
        public static void And(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
        }
        
        public static void Or(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
        }
        
        public static void ExclusiveOr(ref imat2x3 t1, ref imat2x3 t2, out imat2x3 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
        }
        
        public static void Equal(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
        }
        
        public static void GreaterThan(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
        }
        
        public static void GreaterThanEqual(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
        }
        
        public static void LessThan(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
        }
        
        public static void LessThanEqual(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
        }
        
        public static void NotEqual(ref imat2x3 t1, ref imat2x3 t2, out bmat2x3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
        }
        
        public static void UnaryPlus(ref imat2x4 t, out imat2x4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
        }
        
        public static void Negate(ref imat2x4 t, out imat2x4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
        }
        
        public static void OnesComplement(ref imat2x4 t, out imat2x4 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m03 = ~t.m03;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
            r.m13 = ~t.m13;
        }
        
        public static void Increment(ref imat2x4 t, out imat2x4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
        }
        
        public static void Decrement(ref imat2x4 t, out imat2x4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
        }
        
        public static void Add(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
        }
        
        public static void Subtract(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
        }
        
        public static void Multiply(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
        }
        
        public static void Divide(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
        }
        
        public static void Modulo(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
        }
        
        public static void And(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m03 = s1 & t2.m03;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
            r.m13 = s1 & t2.m13;
        }
        
        public static void Or(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m03 = s1 | t2.m03;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
            r.m13 = s1 | t2.m13;
        }
        
        public static void ExclusiveOr(int s1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m03 = s1 ^ t2.m03;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
            r.m13 = s1 ^ t2.m13;
        }
        
        public static void Add(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
        }
        
        public static void Subtract(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
        }
        
        public static void Multiply(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
        }
        
        public static void Divide(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
        }
        
        public static void Modulo(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
        }
        
        public static void And(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m03 = t1.m03 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
            r.m13 = t1.m13 & s2;
        }
        
        public static void Or(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m03 = t1.m03 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
            r.m13 = t1.m13 | s2;
        }
        
        public static void ExclusiveOr(ref imat2x4 t1, int s2, out imat2x4 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m03 = t1.m03 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
            r.m13 = t1.m13 ^ s2;
        }
        
        public static void Add(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
        }
        
        public static void Subtract(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
        }
        
        public static void Multiply(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
        }
        
        public static void Divide(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
        }
        
        public static void Modulo(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
        }
        
        public static void And(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m03 = t1.m03 & t2.m03;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
            r.m13 = t1.m13 & t2.m13;
        }
        
        public static void Or(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m03 = t1.m03 | t2.m03;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
            r.m13 = t1.m13 | t2.m13;
        }
        
        public static void ExclusiveOr(ref imat2x4 t1, ref imat2x4 t2, out imat2x4 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m03 = t1.m03 ^ t2.m03;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
            r.m13 = t1.m13 ^ t2.m13;
        }
        
        public static void Equal(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
        }
        
        public static void GreaterThan(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
        }
        
        public static void GreaterThanEqual(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
        }
        
        public static void LessThan(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
        }
        
        public static void LessThanEqual(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
        }
        
        public static void NotEqual(ref imat2x4 t1, ref imat2x4 t2, out bmat2x4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
        }
        
        public static void UnaryPlus(ref imat3x2 t, out imat3x2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
        }
        
        public static void Negate(ref imat3x2 t, out imat3x2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
        }
        
        public static void OnesComplement(ref imat3x2 t, out imat3x2 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
        }
        
        public static void Increment(ref imat3x2 t, out imat3x2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
        }
        
        public static void Decrement(ref imat3x2 t, out imat3x2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
        }
        
        public static void Add(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
        }
        
        public static void Subtract(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
        }
        
        public static void Multiply(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
        }
        
        public static void Divide(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
        }
        
        public static void Modulo(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
        }
        
        public static void And(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
        }
        
        public static void Or(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
        }
        
        public static void ExclusiveOr(int s1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
        }
        
        public static void Add(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
        }
        
        public static void Subtract(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
        }
        
        public static void Multiply(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
        }
        
        public static void Divide(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
        }
        
        public static void Modulo(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
        }
        
        public static void And(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
        }
        
        public static void Or(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
        }
        
        public static void ExclusiveOr(ref imat3x2 t1, int s2, out imat3x2 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
        }
        
        public static void Add(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
        }
        
        public static void Subtract(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
        }
        
        public static void Multiply(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
        }
        
        public static void Divide(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
        }
        
        public static void Modulo(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
        }
        
        public static void And(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
        }
        
        public static void Or(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
        }
        
        public static void ExclusiveOr(ref imat3x2 t1, ref imat3x2 t2, out imat3x2 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
        }
        
        public static void Equal(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
        }
        
        public static void GreaterThan(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
        }
        
        public static void GreaterThanEqual(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
        }
        
        public static void LessThan(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
        }
        
        public static void LessThanEqual(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
        }
        
        public static void NotEqual(ref imat3x2 t1, ref imat3x2 t2, out bmat3x2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
        }
        
        public static void UnaryPlus(ref imat3 t, out imat3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
        }
        
        public static void Negate(ref imat3 t, out imat3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
        }
        
        public static void OnesComplement(ref imat3 t, out imat3 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
            r.m22 = ~t.m22;
        }
        
        public static void Increment(ref imat3 t, out imat3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
        }
        
        public static void Decrement(ref imat3 t, out imat3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
        }
        
        public static void Add(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
        }
        
        public static void Subtract(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
        }
        
        public static void Multiply(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
        }
        
        public static void Divide(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
        }
        
        public static void Modulo(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
        }
        
        public static void And(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
            r.m22 = s1 & t2.m22;
        }
        
        public static void Or(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
            r.m22 = s1 | t2.m22;
        }
        
        public static void ExclusiveOr(int s1, ref imat3 t2, out imat3 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
            r.m22 = s1 ^ t2.m22;
        }
        
        public static void Add(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
        }
        
        public static void Subtract(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
        }
        
        public static void Multiply(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
        }
        
        public static void Divide(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
        }
        
        public static void Modulo(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
        }
        
        public static void And(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
            r.m22 = t1.m22 & s2;
        }
        
        public static void Or(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
            r.m22 = t1.m22 | s2;
        }
        
        public static void ExclusiveOr(ref imat3 t1, int s2, out imat3 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
            r.m22 = t1.m22 ^ s2;
        }
        
        public static void Add(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
        }
        
        public static void Subtract(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
        }
        
        public static void Multiply(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
        }
        
        public static void Divide(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
        }
        
        public static void Modulo(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
        }
        
        public static void And(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
            r.m22 = t1.m22 & t2.m22;
        }
        
        public static void Or(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
            r.m22 = t1.m22 | t2.m22;
        }
        
        public static void ExclusiveOr(ref imat3 t1, ref imat3 t2, out imat3 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
            r.m22 = t1.m22 ^ t2.m22;
        }
        
        public static void Equal(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
        }
        
        public static void GreaterThan(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
        }
        
        public static void GreaterThanEqual(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
        }
        
        public static void LessThan(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
        }
        
        public static void LessThanEqual(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
        }
        
        public static void NotEqual(ref imat3 t1, ref imat3 t2, out bmat3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
        }
        
        public static void UnaryPlus(ref imat3x4 t, out imat3x4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m23 = +t.m23;
        }
        
        public static void Negate(ref imat3x4 t, out imat3x4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m23 = -t.m23;
        }
        
        public static void OnesComplement(ref imat3x4 t, out imat3x4 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m03 = ~t.m03;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
            r.m13 = ~t.m13;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
            r.m22 = ~t.m22;
            r.m23 = ~t.m23;
        }
        
        public static void Increment(ref imat3x4 t, out imat3x4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m23 = ++t.m23;
        }
        
        public static void Decrement(ref imat3x4 t, out imat3x4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m23 = --t.m23;
        }
        
        public static void Add(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m23 = s1 + t2.m23;
        }
        
        public static void Subtract(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m23 = s1 - t2.m23;
        }
        
        public static void Multiply(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m23 = s1 * t2.m23;
        }
        
        public static void Divide(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m23 = s1 / t2.m23;
        }
        
        public static void Modulo(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m23 = s1 % t2.m23;
        }
        
        public static void And(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m03 = s1 & t2.m03;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
            r.m13 = s1 & t2.m13;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
            r.m22 = s1 & t2.m22;
            r.m23 = s1 & t2.m23;
        }
        
        public static void Or(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m03 = s1 | t2.m03;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
            r.m13 = s1 | t2.m13;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
            r.m22 = s1 | t2.m22;
            r.m23 = s1 | t2.m23;
        }
        
        public static void ExclusiveOr(int s1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m03 = s1 ^ t2.m03;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
            r.m13 = s1 ^ t2.m13;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
            r.m22 = s1 ^ t2.m22;
            r.m23 = s1 ^ t2.m23;
        }
        
        public static void Add(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m23 = t1.m23 + s2;
        }
        
        public static void Subtract(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m23 = t1.m23 - s2;
        }
        
        public static void Multiply(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m23 = t1.m23 * s2;
        }
        
        public static void Divide(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m23 = t1.m23 / s2;
        }
        
        public static void Modulo(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m23 = t1.m23 % s2;
        }
        
        public static void And(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m03 = t1.m03 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
            r.m13 = t1.m13 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
            r.m22 = t1.m22 & s2;
            r.m23 = t1.m23 & s2;
        }
        
        public static void Or(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m03 = t1.m03 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
            r.m13 = t1.m13 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
            r.m22 = t1.m22 | s2;
            r.m23 = t1.m23 | s2;
        }
        
        public static void ExclusiveOr(ref imat3x4 t1, int s2, out imat3x4 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m03 = t1.m03 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
            r.m13 = t1.m13 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
            r.m22 = t1.m22 ^ s2;
            r.m23 = t1.m23 ^ s2;
        }
        
        public static void Add(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m23 = t1.m23 + t2.m23;
        }
        
        public static void Subtract(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m23 = t1.m23 - t2.m23;
        }
        
        public static void Multiply(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m23 = t1.m23 * t2.m23;
        }
        
        public static void Divide(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m23 = t1.m23 / t2.m23;
        }
        
        public static void Modulo(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m23 = t1.m23 % t2.m23;
        }
        
        public static void And(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m03 = t1.m03 & t2.m03;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
            r.m13 = t1.m13 & t2.m13;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
            r.m22 = t1.m22 & t2.m22;
            r.m23 = t1.m23 & t2.m23;
        }
        
        public static void Or(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m03 = t1.m03 | t2.m03;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
            r.m13 = t1.m13 | t2.m13;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
            r.m22 = t1.m22 | t2.m22;
            r.m23 = t1.m23 | t2.m23;
        }
        
        public static void ExclusiveOr(ref imat3x4 t1, ref imat3x4 t2, out imat3x4 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m03 = t1.m03 ^ t2.m03;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
            r.m13 = t1.m13 ^ t2.m13;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
            r.m22 = t1.m22 ^ t2.m22;
            r.m23 = t1.m23 ^ t2.m23;
        }
        
        public static void Equal(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m23 = t1.m23 == t2.m23;
        }
        
        public static void GreaterThan(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m23 = t1.m23 > t2.m23;
        }
        
        public static void GreaterThanEqual(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m23 = t1.m23 >= t2.m23;
        }
        
        public static void LessThan(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m23 = t1.m23 < t2.m23;
        }
        
        public static void LessThanEqual(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m23 = t1.m23 <= t2.m23;
        }
        
        public static void NotEqual(ref imat3x4 t1, ref imat3x4 t2, out bmat3x4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m23 = t1.m23 != t2.m23;
        }
        
        public static void UnaryPlus(ref imat4x2 t, out imat4x2 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
        }
        
        public static void Negate(ref imat4x2 t, out imat4x2 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
        }
        
        public static void OnesComplement(ref imat4x2 t, out imat4x2 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
            r.m30 = ~t.m30;
            r.m31 = ~t.m31;
        }
        
        public static void Increment(ref imat4x2 t, out imat4x2 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
        }
        
        public static void Decrement(ref imat4x2 t, out imat4x2 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
        }
        
        public static void Add(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
        }
        
        public static void Subtract(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
        }
        
        public static void Multiply(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
        }
        
        public static void Divide(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
        }
        
        public static void Modulo(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
        }
        
        public static void And(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
            r.m30 = s1 & t2.m30;
            r.m31 = s1 & t2.m31;
        }
        
        public static void Or(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
            r.m30 = s1 | t2.m30;
            r.m31 = s1 | t2.m31;
        }
        
        public static void ExclusiveOr(int s1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
            r.m30 = s1 ^ t2.m30;
            r.m31 = s1 ^ t2.m31;
        }
        
        public static void Add(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
        }
        
        public static void Subtract(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
        }
        
        public static void Multiply(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
        }
        
        public static void Divide(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
        }
        
        public static void Modulo(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
        }
        
        public static void And(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
            r.m30 = t1.m30 & s2;
            r.m31 = t1.m31 & s2;
        }
        
        public static void Or(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
            r.m30 = t1.m30 | s2;
            r.m31 = t1.m31 | s2;
        }
        
        public static void ExclusiveOr(ref imat4x2 t1, int s2, out imat4x2 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
            r.m30 = t1.m30 ^ s2;
            r.m31 = t1.m31 ^ s2;
        }
        
        public static void Add(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
        }
        
        public static void Subtract(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
        }
        
        public static void Multiply(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
        }
        
        public static void Divide(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
        }
        
        public static void Modulo(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
        }
        
        public static void And(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
            r.m30 = t1.m30 & t2.m30;
            r.m31 = t1.m31 & t2.m31;
        }
        
        public static void Or(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
            r.m30 = t1.m30 | t2.m30;
            r.m31 = t1.m31 | t2.m31;
        }
        
        public static void ExclusiveOr(ref imat4x2 t1, ref imat4x2 t2, out imat4x2 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
            r.m30 = t1.m30 ^ t2.m30;
            r.m31 = t1.m31 ^ t2.m31;
        }
        
        public static void Equal(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
        }
        
        public static void GreaterThan(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
        }
        
        public static void GreaterThanEqual(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
        }
        
        public static void LessThan(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
        }
        
        public static void LessThanEqual(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
        }
        
        public static void NotEqual(ref imat4x2 t1, ref imat4x2 t2, out bmat4x2 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
        }
        
        public static void UnaryPlus(ref imat4x3 t, out imat4x3 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
            r.m32 = +t.m32;
        }
        
        public static void Negate(ref imat4x3 t, out imat4x3 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
            r.m32 = -t.m32;
        }
        
        public static void OnesComplement(ref imat4x3 t, out imat4x3 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
            r.m22 = ~t.m22;
            r.m30 = ~t.m30;
            r.m31 = ~t.m31;
            r.m32 = ~t.m32;
        }
        
        public static void Increment(ref imat4x3 t, out imat4x3 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
            r.m32 = ++t.m32;
        }
        
        public static void Decrement(ref imat4x3 t, out imat4x3 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
            r.m32 = --t.m32;
        }
        
        public static void Add(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
            r.m32 = s1 + t2.m32;
        }
        
        public static void Subtract(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
            r.m32 = s1 - t2.m32;
        }
        
        public static void Multiply(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
            r.m32 = s1 * t2.m32;
        }
        
        public static void Divide(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
            r.m32 = s1 / t2.m32;
        }
        
        public static void Modulo(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
            r.m32 = s1 % t2.m32;
        }
        
        public static void And(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
            r.m22 = s1 & t2.m22;
            r.m30 = s1 & t2.m30;
            r.m31 = s1 & t2.m31;
            r.m32 = s1 & t2.m32;
        }
        
        public static void Or(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
            r.m22 = s1 | t2.m22;
            r.m30 = s1 | t2.m30;
            r.m31 = s1 | t2.m31;
            r.m32 = s1 | t2.m32;
        }
        
        public static void ExclusiveOr(int s1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
            r.m22 = s1 ^ t2.m22;
            r.m30 = s1 ^ t2.m30;
            r.m31 = s1 ^ t2.m31;
            r.m32 = s1 ^ t2.m32;
        }
        
        public static void Add(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
            r.m32 = t1.m32 + s2;
        }
        
        public static void Subtract(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
            r.m32 = t1.m32 - s2;
        }
        
        public static void Multiply(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
            r.m32 = t1.m32 * s2;
        }
        
        public static void Divide(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
            r.m32 = t1.m32 / s2;
        }
        
        public static void Modulo(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
            r.m32 = t1.m32 % s2;
        }
        
        public static void And(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
            r.m22 = t1.m22 & s2;
            r.m30 = t1.m30 & s2;
            r.m31 = t1.m31 & s2;
            r.m32 = t1.m32 & s2;
        }
        
        public static void Or(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
            r.m22 = t1.m22 | s2;
            r.m30 = t1.m30 | s2;
            r.m31 = t1.m31 | s2;
            r.m32 = t1.m32 | s2;
        }
        
        public static void ExclusiveOr(ref imat4x3 t1, int s2, out imat4x3 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
            r.m22 = t1.m22 ^ s2;
            r.m30 = t1.m30 ^ s2;
            r.m31 = t1.m31 ^ s2;
            r.m32 = t1.m32 ^ s2;
        }
        
        public static void Add(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
            r.m32 = t1.m32 + t2.m32;
        }
        
        public static void Subtract(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
            r.m32 = t1.m32 - t2.m32;
        }
        
        public static void Multiply(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
            r.m32 = t1.m32 * t2.m32;
        }
        
        public static void Divide(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
            r.m32 = t1.m32 / t2.m32;
        }
        
        public static void Modulo(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
            r.m32 = t1.m32 % t2.m32;
        }
        
        public static void And(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
            r.m22 = t1.m22 & t2.m22;
            r.m30 = t1.m30 & t2.m30;
            r.m31 = t1.m31 & t2.m31;
            r.m32 = t1.m32 & t2.m32;
        }
        
        public static void Or(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
            r.m22 = t1.m22 | t2.m22;
            r.m30 = t1.m30 | t2.m30;
            r.m31 = t1.m31 | t2.m31;
            r.m32 = t1.m32 | t2.m32;
        }
        
        public static void ExclusiveOr(ref imat4x3 t1, ref imat4x3 t2, out imat4x3 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
            r.m22 = t1.m22 ^ t2.m22;
            r.m30 = t1.m30 ^ t2.m30;
            r.m31 = t1.m31 ^ t2.m31;
            r.m32 = t1.m32 ^ t2.m32;
        }
        
        public static void Equal(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
            r.m32 = t1.m32 == t2.m32;
        }
        
        public static void GreaterThan(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
            r.m32 = t1.m32 > t2.m32;
        }
        
        public static void GreaterThanEqual(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
            r.m32 = t1.m32 >= t2.m32;
        }
        
        public static void LessThan(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
            r.m32 = t1.m32 < t2.m32;
        }
        
        public static void LessThanEqual(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
            r.m32 = t1.m32 <= t2.m32;
        }
        
        public static void NotEqual(ref imat4x3 t1, ref imat4x3 t2, out bmat4x3 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
            r.m32 = t1.m32 != t2.m32;
        }
        
        public static void UnaryPlus(ref imat4 t, out imat4 r) {
            r.m00 = +t.m00;
            r.m01 = +t.m01;
            r.m02 = +t.m02;
            r.m03 = +t.m03;
            r.m10 = +t.m10;
            r.m11 = +t.m11;
            r.m12 = +t.m12;
            r.m13 = +t.m13;
            r.m20 = +t.m20;
            r.m21 = +t.m21;
            r.m22 = +t.m22;
            r.m23 = +t.m23;
            r.m30 = +t.m30;
            r.m31 = +t.m31;
            r.m32 = +t.m32;
            r.m33 = +t.m33;
        }
        
        public static void Negate(ref imat4 t, out imat4 r) {
            r.m00 = -t.m00;
            r.m01 = -t.m01;
            r.m02 = -t.m02;
            r.m03 = -t.m03;
            r.m10 = -t.m10;
            r.m11 = -t.m11;
            r.m12 = -t.m12;
            r.m13 = -t.m13;
            r.m20 = -t.m20;
            r.m21 = -t.m21;
            r.m22 = -t.m22;
            r.m23 = -t.m23;
            r.m30 = -t.m30;
            r.m31 = -t.m31;
            r.m32 = -t.m32;
            r.m33 = -t.m33;
        }
        
        public static void OnesComplement(ref imat4 t, out imat4 r) {
            r.m00 = ~t.m00;
            r.m01 = ~t.m01;
            r.m02 = ~t.m02;
            r.m03 = ~t.m03;
            r.m10 = ~t.m10;
            r.m11 = ~t.m11;
            r.m12 = ~t.m12;
            r.m13 = ~t.m13;
            r.m20 = ~t.m20;
            r.m21 = ~t.m21;
            r.m22 = ~t.m22;
            r.m23 = ~t.m23;
            r.m30 = ~t.m30;
            r.m31 = ~t.m31;
            r.m32 = ~t.m32;
            r.m33 = ~t.m33;
        }
        
        public static void Increment(ref imat4 t, out imat4 r) {
            r.m00 = ++t.m00;
            r.m01 = ++t.m01;
            r.m02 = ++t.m02;
            r.m03 = ++t.m03;
            r.m10 = ++t.m10;
            r.m11 = ++t.m11;
            r.m12 = ++t.m12;
            r.m13 = ++t.m13;
            r.m20 = ++t.m20;
            r.m21 = ++t.m21;
            r.m22 = ++t.m22;
            r.m23 = ++t.m23;
            r.m30 = ++t.m30;
            r.m31 = ++t.m31;
            r.m32 = ++t.m32;
            r.m33 = ++t.m33;
        }
        
        public static void Decrement(ref imat4 t, out imat4 r) {
            r.m00 = --t.m00;
            r.m01 = --t.m01;
            r.m02 = --t.m02;
            r.m03 = --t.m03;
            r.m10 = --t.m10;
            r.m11 = --t.m11;
            r.m12 = --t.m12;
            r.m13 = --t.m13;
            r.m20 = --t.m20;
            r.m21 = --t.m21;
            r.m22 = --t.m22;
            r.m23 = --t.m23;
            r.m30 = --t.m30;
            r.m31 = --t.m31;
            r.m32 = --t.m32;
            r.m33 = --t.m33;
        }
        
        public static void Add(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 + t2.m00;
            r.m01 = s1 + t2.m01;
            r.m02 = s1 + t2.m02;
            r.m03 = s1 + t2.m03;
            r.m10 = s1 + t2.m10;
            r.m11 = s1 + t2.m11;
            r.m12 = s1 + t2.m12;
            r.m13 = s1 + t2.m13;
            r.m20 = s1 + t2.m20;
            r.m21 = s1 + t2.m21;
            r.m22 = s1 + t2.m22;
            r.m23 = s1 + t2.m23;
            r.m30 = s1 + t2.m30;
            r.m31 = s1 + t2.m31;
            r.m32 = s1 + t2.m32;
            r.m33 = s1 + t2.m33;
        }
        
        public static void Subtract(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 - t2.m00;
            r.m01 = s1 - t2.m01;
            r.m02 = s1 - t2.m02;
            r.m03 = s1 - t2.m03;
            r.m10 = s1 - t2.m10;
            r.m11 = s1 - t2.m11;
            r.m12 = s1 - t2.m12;
            r.m13 = s1 - t2.m13;
            r.m20 = s1 - t2.m20;
            r.m21 = s1 - t2.m21;
            r.m22 = s1 - t2.m22;
            r.m23 = s1 - t2.m23;
            r.m30 = s1 - t2.m30;
            r.m31 = s1 - t2.m31;
            r.m32 = s1 - t2.m32;
            r.m33 = s1 - t2.m33;
        }
        
        public static void Multiply(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 * t2.m00;
            r.m01 = s1 * t2.m01;
            r.m02 = s1 * t2.m02;
            r.m03 = s1 * t2.m03;
            r.m10 = s1 * t2.m10;
            r.m11 = s1 * t2.m11;
            r.m12 = s1 * t2.m12;
            r.m13 = s1 * t2.m13;
            r.m20 = s1 * t2.m20;
            r.m21 = s1 * t2.m21;
            r.m22 = s1 * t2.m22;
            r.m23 = s1 * t2.m23;
            r.m30 = s1 * t2.m30;
            r.m31 = s1 * t2.m31;
            r.m32 = s1 * t2.m32;
            r.m33 = s1 * t2.m33;
        }
        
        public static void Divide(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 / t2.m00;
            r.m01 = s1 / t2.m01;
            r.m02 = s1 / t2.m02;
            r.m03 = s1 / t2.m03;
            r.m10 = s1 / t2.m10;
            r.m11 = s1 / t2.m11;
            r.m12 = s1 / t2.m12;
            r.m13 = s1 / t2.m13;
            r.m20 = s1 / t2.m20;
            r.m21 = s1 / t2.m21;
            r.m22 = s1 / t2.m22;
            r.m23 = s1 / t2.m23;
            r.m30 = s1 / t2.m30;
            r.m31 = s1 / t2.m31;
            r.m32 = s1 / t2.m32;
            r.m33 = s1 / t2.m33;
        }
        
        public static void Modulo(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 % t2.m00;
            r.m01 = s1 % t2.m01;
            r.m02 = s1 % t2.m02;
            r.m03 = s1 % t2.m03;
            r.m10 = s1 % t2.m10;
            r.m11 = s1 % t2.m11;
            r.m12 = s1 % t2.m12;
            r.m13 = s1 % t2.m13;
            r.m20 = s1 % t2.m20;
            r.m21 = s1 % t2.m21;
            r.m22 = s1 % t2.m22;
            r.m23 = s1 % t2.m23;
            r.m30 = s1 % t2.m30;
            r.m31 = s1 % t2.m31;
            r.m32 = s1 % t2.m32;
            r.m33 = s1 % t2.m33;
        }
        
        public static void And(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 & t2.m00;
            r.m01 = s1 & t2.m01;
            r.m02 = s1 & t2.m02;
            r.m03 = s1 & t2.m03;
            r.m10 = s1 & t2.m10;
            r.m11 = s1 & t2.m11;
            r.m12 = s1 & t2.m12;
            r.m13 = s1 & t2.m13;
            r.m20 = s1 & t2.m20;
            r.m21 = s1 & t2.m21;
            r.m22 = s1 & t2.m22;
            r.m23 = s1 & t2.m23;
            r.m30 = s1 & t2.m30;
            r.m31 = s1 & t2.m31;
            r.m32 = s1 & t2.m32;
            r.m33 = s1 & t2.m33;
        }
        
        public static void Or(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 | t2.m00;
            r.m01 = s1 | t2.m01;
            r.m02 = s1 | t2.m02;
            r.m03 = s1 | t2.m03;
            r.m10 = s1 | t2.m10;
            r.m11 = s1 | t2.m11;
            r.m12 = s1 | t2.m12;
            r.m13 = s1 | t2.m13;
            r.m20 = s1 | t2.m20;
            r.m21 = s1 | t2.m21;
            r.m22 = s1 | t2.m22;
            r.m23 = s1 | t2.m23;
            r.m30 = s1 | t2.m30;
            r.m31 = s1 | t2.m31;
            r.m32 = s1 | t2.m32;
            r.m33 = s1 | t2.m33;
        }
        
        public static void ExclusiveOr(int s1, ref imat4 t2, out imat4 r) {
            r.m00 = s1 ^ t2.m00;
            r.m01 = s1 ^ t2.m01;
            r.m02 = s1 ^ t2.m02;
            r.m03 = s1 ^ t2.m03;
            r.m10 = s1 ^ t2.m10;
            r.m11 = s1 ^ t2.m11;
            r.m12 = s1 ^ t2.m12;
            r.m13 = s1 ^ t2.m13;
            r.m20 = s1 ^ t2.m20;
            r.m21 = s1 ^ t2.m21;
            r.m22 = s1 ^ t2.m22;
            r.m23 = s1 ^ t2.m23;
            r.m30 = s1 ^ t2.m30;
            r.m31 = s1 ^ t2.m31;
            r.m32 = s1 ^ t2.m32;
            r.m33 = s1 ^ t2.m33;
        }
        
        public static void Add(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 + s2;
            r.m01 = t1.m01 + s2;
            r.m02 = t1.m02 + s2;
            r.m03 = t1.m03 + s2;
            r.m10 = t1.m10 + s2;
            r.m11 = t1.m11 + s2;
            r.m12 = t1.m12 + s2;
            r.m13 = t1.m13 + s2;
            r.m20 = t1.m20 + s2;
            r.m21 = t1.m21 + s2;
            r.m22 = t1.m22 + s2;
            r.m23 = t1.m23 + s2;
            r.m30 = t1.m30 + s2;
            r.m31 = t1.m31 + s2;
            r.m32 = t1.m32 + s2;
            r.m33 = t1.m33 + s2;
        }
        
        public static void Subtract(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 - s2;
            r.m01 = t1.m01 - s2;
            r.m02 = t1.m02 - s2;
            r.m03 = t1.m03 - s2;
            r.m10 = t1.m10 - s2;
            r.m11 = t1.m11 - s2;
            r.m12 = t1.m12 - s2;
            r.m13 = t1.m13 - s2;
            r.m20 = t1.m20 - s2;
            r.m21 = t1.m21 - s2;
            r.m22 = t1.m22 - s2;
            r.m23 = t1.m23 - s2;
            r.m30 = t1.m30 - s2;
            r.m31 = t1.m31 - s2;
            r.m32 = t1.m32 - s2;
            r.m33 = t1.m33 - s2;
        }
        
        public static void Multiply(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 * s2;
            r.m01 = t1.m01 * s2;
            r.m02 = t1.m02 * s2;
            r.m03 = t1.m03 * s2;
            r.m10 = t1.m10 * s2;
            r.m11 = t1.m11 * s2;
            r.m12 = t1.m12 * s2;
            r.m13 = t1.m13 * s2;
            r.m20 = t1.m20 * s2;
            r.m21 = t1.m21 * s2;
            r.m22 = t1.m22 * s2;
            r.m23 = t1.m23 * s2;
            r.m30 = t1.m30 * s2;
            r.m31 = t1.m31 * s2;
            r.m32 = t1.m32 * s2;
            r.m33 = t1.m33 * s2;
        }
        
        public static void Divide(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 / s2;
            r.m01 = t1.m01 / s2;
            r.m02 = t1.m02 / s2;
            r.m03 = t1.m03 / s2;
            r.m10 = t1.m10 / s2;
            r.m11 = t1.m11 / s2;
            r.m12 = t1.m12 / s2;
            r.m13 = t1.m13 / s2;
            r.m20 = t1.m20 / s2;
            r.m21 = t1.m21 / s2;
            r.m22 = t1.m22 / s2;
            r.m23 = t1.m23 / s2;
            r.m30 = t1.m30 / s2;
            r.m31 = t1.m31 / s2;
            r.m32 = t1.m32 / s2;
            r.m33 = t1.m33 / s2;
        }
        
        public static void Modulo(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 % s2;
            r.m01 = t1.m01 % s2;
            r.m02 = t1.m02 % s2;
            r.m03 = t1.m03 % s2;
            r.m10 = t1.m10 % s2;
            r.m11 = t1.m11 % s2;
            r.m12 = t1.m12 % s2;
            r.m13 = t1.m13 % s2;
            r.m20 = t1.m20 % s2;
            r.m21 = t1.m21 % s2;
            r.m22 = t1.m22 % s2;
            r.m23 = t1.m23 % s2;
            r.m30 = t1.m30 % s2;
            r.m31 = t1.m31 % s2;
            r.m32 = t1.m32 % s2;
            r.m33 = t1.m33 % s2;
        }
        
        public static void And(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 & s2;
            r.m01 = t1.m01 & s2;
            r.m02 = t1.m02 & s2;
            r.m03 = t1.m03 & s2;
            r.m10 = t1.m10 & s2;
            r.m11 = t1.m11 & s2;
            r.m12 = t1.m12 & s2;
            r.m13 = t1.m13 & s2;
            r.m20 = t1.m20 & s2;
            r.m21 = t1.m21 & s2;
            r.m22 = t1.m22 & s2;
            r.m23 = t1.m23 & s2;
            r.m30 = t1.m30 & s2;
            r.m31 = t1.m31 & s2;
            r.m32 = t1.m32 & s2;
            r.m33 = t1.m33 & s2;
        }
        
        public static void Or(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 | s2;
            r.m01 = t1.m01 | s2;
            r.m02 = t1.m02 | s2;
            r.m03 = t1.m03 | s2;
            r.m10 = t1.m10 | s2;
            r.m11 = t1.m11 | s2;
            r.m12 = t1.m12 | s2;
            r.m13 = t1.m13 | s2;
            r.m20 = t1.m20 | s2;
            r.m21 = t1.m21 | s2;
            r.m22 = t1.m22 | s2;
            r.m23 = t1.m23 | s2;
            r.m30 = t1.m30 | s2;
            r.m31 = t1.m31 | s2;
            r.m32 = t1.m32 | s2;
            r.m33 = t1.m33 | s2;
        }
        
        public static void ExclusiveOr(ref imat4 t1, int s2, out imat4 r) {
            r.m00 = t1.m00 ^ s2;
            r.m01 = t1.m01 ^ s2;
            r.m02 = t1.m02 ^ s2;
            r.m03 = t1.m03 ^ s2;
            r.m10 = t1.m10 ^ s2;
            r.m11 = t1.m11 ^ s2;
            r.m12 = t1.m12 ^ s2;
            r.m13 = t1.m13 ^ s2;
            r.m20 = t1.m20 ^ s2;
            r.m21 = t1.m21 ^ s2;
            r.m22 = t1.m22 ^ s2;
            r.m23 = t1.m23 ^ s2;
            r.m30 = t1.m30 ^ s2;
            r.m31 = t1.m31 ^ s2;
            r.m32 = t1.m32 ^ s2;
            r.m33 = t1.m33 ^ s2;
        }
        
        public static void Add(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 + t2.m00;
            r.m01 = t1.m01 + t2.m01;
            r.m02 = t1.m02 + t2.m02;
            r.m03 = t1.m03 + t2.m03;
            r.m10 = t1.m10 + t2.m10;
            r.m11 = t1.m11 + t2.m11;
            r.m12 = t1.m12 + t2.m12;
            r.m13 = t1.m13 + t2.m13;
            r.m20 = t1.m20 + t2.m20;
            r.m21 = t1.m21 + t2.m21;
            r.m22 = t1.m22 + t2.m22;
            r.m23 = t1.m23 + t2.m23;
            r.m30 = t1.m30 + t2.m30;
            r.m31 = t1.m31 + t2.m31;
            r.m32 = t1.m32 + t2.m32;
            r.m33 = t1.m33 + t2.m33;
        }
        
        public static void Subtract(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 - t2.m00;
            r.m01 = t1.m01 - t2.m01;
            r.m02 = t1.m02 - t2.m02;
            r.m03 = t1.m03 - t2.m03;
            r.m10 = t1.m10 - t2.m10;
            r.m11 = t1.m11 - t2.m11;
            r.m12 = t1.m12 - t2.m12;
            r.m13 = t1.m13 - t2.m13;
            r.m20 = t1.m20 - t2.m20;
            r.m21 = t1.m21 - t2.m21;
            r.m22 = t1.m22 - t2.m22;
            r.m23 = t1.m23 - t2.m23;
            r.m30 = t1.m30 - t2.m30;
            r.m31 = t1.m31 - t2.m31;
            r.m32 = t1.m32 - t2.m32;
            r.m33 = t1.m33 - t2.m33;
        }
        
        public static void Multiply(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 * t2.m00;
            r.m01 = t1.m01 * t2.m01;
            r.m02 = t1.m02 * t2.m02;
            r.m03 = t1.m03 * t2.m03;
            r.m10 = t1.m10 * t2.m10;
            r.m11 = t1.m11 * t2.m11;
            r.m12 = t1.m12 * t2.m12;
            r.m13 = t1.m13 * t2.m13;
            r.m20 = t1.m20 * t2.m20;
            r.m21 = t1.m21 * t2.m21;
            r.m22 = t1.m22 * t2.m22;
            r.m23 = t1.m23 * t2.m23;
            r.m30 = t1.m30 * t2.m30;
            r.m31 = t1.m31 * t2.m31;
            r.m32 = t1.m32 * t2.m32;
            r.m33 = t1.m33 * t2.m33;
        }
        
        public static void Divide(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 / t2.m00;
            r.m01 = t1.m01 / t2.m01;
            r.m02 = t1.m02 / t2.m02;
            r.m03 = t1.m03 / t2.m03;
            r.m10 = t1.m10 / t2.m10;
            r.m11 = t1.m11 / t2.m11;
            r.m12 = t1.m12 / t2.m12;
            r.m13 = t1.m13 / t2.m13;
            r.m20 = t1.m20 / t2.m20;
            r.m21 = t1.m21 / t2.m21;
            r.m22 = t1.m22 / t2.m22;
            r.m23 = t1.m23 / t2.m23;
            r.m30 = t1.m30 / t2.m30;
            r.m31 = t1.m31 / t2.m31;
            r.m32 = t1.m32 / t2.m32;
            r.m33 = t1.m33 / t2.m33;
        }
        
        public static void Modulo(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 % t2.m00;
            r.m01 = t1.m01 % t2.m01;
            r.m02 = t1.m02 % t2.m02;
            r.m03 = t1.m03 % t2.m03;
            r.m10 = t1.m10 % t2.m10;
            r.m11 = t1.m11 % t2.m11;
            r.m12 = t1.m12 % t2.m12;
            r.m13 = t1.m13 % t2.m13;
            r.m20 = t1.m20 % t2.m20;
            r.m21 = t1.m21 % t2.m21;
            r.m22 = t1.m22 % t2.m22;
            r.m23 = t1.m23 % t2.m23;
            r.m30 = t1.m30 % t2.m30;
            r.m31 = t1.m31 % t2.m31;
            r.m32 = t1.m32 % t2.m32;
            r.m33 = t1.m33 % t2.m33;
        }
        
        public static void And(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 & t2.m00;
            r.m01 = t1.m01 & t2.m01;
            r.m02 = t1.m02 & t2.m02;
            r.m03 = t1.m03 & t2.m03;
            r.m10 = t1.m10 & t2.m10;
            r.m11 = t1.m11 & t2.m11;
            r.m12 = t1.m12 & t2.m12;
            r.m13 = t1.m13 & t2.m13;
            r.m20 = t1.m20 & t2.m20;
            r.m21 = t1.m21 & t2.m21;
            r.m22 = t1.m22 & t2.m22;
            r.m23 = t1.m23 & t2.m23;
            r.m30 = t1.m30 & t2.m30;
            r.m31 = t1.m31 & t2.m31;
            r.m32 = t1.m32 & t2.m32;
            r.m33 = t1.m33 & t2.m33;
        }
        
        public static void Or(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 | t2.m00;
            r.m01 = t1.m01 | t2.m01;
            r.m02 = t1.m02 | t2.m02;
            r.m03 = t1.m03 | t2.m03;
            r.m10 = t1.m10 | t2.m10;
            r.m11 = t1.m11 | t2.m11;
            r.m12 = t1.m12 | t2.m12;
            r.m13 = t1.m13 | t2.m13;
            r.m20 = t1.m20 | t2.m20;
            r.m21 = t1.m21 | t2.m21;
            r.m22 = t1.m22 | t2.m22;
            r.m23 = t1.m23 | t2.m23;
            r.m30 = t1.m30 | t2.m30;
            r.m31 = t1.m31 | t2.m31;
            r.m32 = t1.m32 | t2.m32;
            r.m33 = t1.m33 | t2.m33;
        }
        
        public static void ExclusiveOr(ref imat4 t1, ref imat4 t2, out imat4 r) {
            r.m00 = t1.m00 ^ t2.m00;
            r.m01 = t1.m01 ^ t2.m01;
            r.m02 = t1.m02 ^ t2.m02;
            r.m03 = t1.m03 ^ t2.m03;
            r.m10 = t1.m10 ^ t2.m10;
            r.m11 = t1.m11 ^ t2.m11;
            r.m12 = t1.m12 ^ t2.m12;
            r.m13 = t1.m13 ^ t2.m13;
            r.m20 = t1.m20 ^ t2.m20;
            r.m21 = t1.m21 ^ t2.m21;
            r.m22 = t1.m22 ^ t2.m22;
            r.m23 = t1.m23 ^ t2.m23;
            r.m30 = t1.m30 ^ t2.m30;
            r.m31 = t1.m31 ^ t2.m31;
            r.m32 = t1.m32 ^ t2.m32;
            r.m33 = t1.m33 ^ t2.m33;
        }
        
        public static void Equal(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 == t2.m00;
            r.m01 = t1.m01 == t2.m01;
            r.m02 = t1.m02 == t2.m02;
            r.m03 = t1.m03 == t2.m03;
            r.m10 = t1.m10 == t2.m10;
            r.m11 = t1.m11 == t2.m11;
            r.m12 = t1.m12 == t2.m12;
            r.m13 = t1.m13 == t2.m13;
            r.m20 = t1.m20 == t2.m20;
            r.m21 = t1.m21 == t2.m21;
            r.m22 = t1.m22 == t2.m22;
            r.m23 = t1.m23 == t2.m23;
            r.m30 = t1.m30 == t2.m30;
            r.m31 = t1.m31 == t2.m31;
            r.m32 = t1.m32 == t2.m32;
            r.m33 = t1.m33 == t2.m33;
        }
        
        public static void GreaterThan(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 > t2.m00;
            r.m01 = t1.m01 > t2.m01;
            r.m02 = t1.m02 > t2.m02;
            r.m03 = t1.m03 > t2.m03;
            r.m10 = t1.m10 > t2.m10;
            r.m11 = t1.m11 > t2.m11;
            r.m12 = t1.m12 > t2.m12;
            r.m13 = t1.m13 > t2.m13;
            r.m20 = t1.m20 > t2.m20;
            r.m21 = t1.m21 > t2.m21;
            r.m22 = t1.m22 > t2.m22;
            r.m23 = t1.m23 > t2.m23;
            r.m30 = t1.m30 > t2.m30;
            r.m31 = t1.m31 > t2.m31;
            r.m32 = t1.m32 > t2.m32;
            r.m33 = t1.m33 > t2.m33;
        }
        
        public static void GreaterThanEqual(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 >= t2.m00;
            r.m01 = t1.m01 >= t2.m01;
            r.m02 = t1.m02 >= t2.m02;
            r.m03 = t1.m03 >= t2.m03;
            r.m10 = t1.m10 >= t2.m10;
            r.m11 = t1.m11 >= t2.m11;
            r.m12 = t1.m12 >= t2.m12;
            r.m13 = t1.m13 >= t2.m13;
            r.m20 = t1.m20 >= t2.m20;
            r.m21 = t1.m21 >= t2.m21;
            r.m22 = t1.m22 >= t2.m22;
            r.m23 = t1.m23 >= t2.m23;
            r.m30 = t1.m30 >= t2.m30;
            r.m31 = t1.m31 >= t2.m31;
            r.m32 = t1.m32 >= t2.m32;
            r.m33 = t1.m33 >= t2.m33;
        }
        
        public static void LessThan(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 < t2.m00;
            r.m01 = t1.m01 < t2.m01;
            r.m02 = t1.m02 < t2.m02;
            r.m03 = t1.m03 < t2.m03;
            r.m10 = t1.m10 < t2.m10;
            r.m11 = t1.m11 < t2.m11;
            r.m12 = t1.m12 < t2.m12;
            r.m13 = t1.m13 < t2.m13;
            r.m20 = t1.m20 < t2.m20;
            r.m21 = t1.m21 < t2.m21;
            r.m22 = t1.m22 < t2.m22;
            r.m23 = t1.m23 < t2.m23;
            r.m30 = t1.m30 < t2.m30;
            r.m31 = t1.m31 < t2.m31;
            r.m32 = t1.m32 < t2.m32;
            r.m33 = t1.m33 < t2.m33;
        }
        
        public static void LessThanEqual(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 <= t2.m00;
            r.m01 = t1.m01 <= t2.m01;
            r.m02 = t1.m02 <= t2.m02;
            r.m03 = t1.m03 <= t2.m03;
            r.m10 = t1.m10 <= t2.m10;
            r.m11 = t1.m11 <= t2.m11;
            r.m12 = t1.m12 <= t2.m12;
            r.m13 = t1.m13 <= t2.m13;
            r.m20 = t1.m20 <= t2.m20;
            r.m21 = t1.m21 <= t2.m21;
            r.m22 = t1.m22 <= t2.m22;
            r.m23 = t1.m23 <= t2.m23;
            r.m30 = t1.m30 <= t2.m30;
            r.m31 = t1.m31 <= t2.m31;
            r.m32 = t1.m32 <= t2.m32;
            r.m33 = t1.m33 <= t2.m33;
        }
        
        public static void NotEqual(ref imat4 t1, ref imat4 t2, out bmat4 r) {
            r.m00 = t1.m00 != t2.m00;
            r.m01 = t1.m01 != t2.m01;
            r.m02 = t1.m02 != t2.m02;
            r.m03 = t1.m03 != t2.m03;
            r.m10 = t1.m10 != t2.m10;
            r.m11 = t1.m11 != t2.m11;
            r.m12 = t1.m12 != t2.m12;
            r.m13 = t1.m13 != t2.m13;
            r.m20 = t1.m20 != t2.m20;
            r.m21 = t1.m21 != t2.m21;
            r.m22 = t1.m22 != t2.m22;
            r.m23 = t1.m23 != t2.m23;
            r.m30 = t1.m30 != t2.m30;
            r.m31 = t1.m31 != t2.m31;
            r.m32 = t1.m32 != t2.m32;
            r.m33 = t1.m33 != t2.m33;
        }
    }
}
